<?php
/**
 * MiNBank external: account list
 *
 * $Source: /cvsroot/minbank/minba/external/accountlist.php,v $
 * $Author: eltres $
 * $Date: 2007/01/22 20:46:29 $
 * $Revision: 1.4 $
 */

require_once("../template/system_head.php");

print("<h1>Kontenliste</h1>\n");

require_once("../utility/utgn_config.php");

chdir("../user/ui_std");
require_once("../usgn_config.php");
require_once("$minsoft_path/utility/utdb_access.php");
require_once("$minsoft_path/user/$cf_local_interface/usli_user.php");
require_once("$minsoft_path/utility/utgn_fault.php");

// log in as technical user and get a security id
$userLi = &new UserLi;
$scramble = md5($utcv_technicalpw);
$userid = $_GET['user'];
$result = $userLi->login(1, $utcv_technicaluser, $scramble);

if(isFault($result)) {
    showError($result[0]['faultString']);
    exit;
}

$secId = $result[1];

// for all banks
chdir("../../minba/ui_std");
require_once("../bagn_config.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_account.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_bank.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_customer.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_centralbank.php");

$centralbankLi = &new CentralbankLi;
$resultb = $centralbankLi->getbanklist($secId,$lang);

if(isFault($resultb)) {
    showError("Zentralbank: ".$resultb[0]['faultString']);
    exit;
}

foreach($resultb as $bank) {
    
    // for all customers of bank
    $bankLi = &new BankLi;
    $resultc = $bankLi->customer_list($secId, $lang, $bank['bankid']);
    
    if(isFault($resultc)) {
        showError("Bank ".$bank['bankid'].": ".$resultc[0]['faultString']);
        exit;
    }
    
    foreach($resultc as $customer) {
        
        // for all accounts of customer
        $customerLi = &new CustomerLi;
        
        $resulta = $customerLi->account_list($secId, $lang, $customer['customerid'], $bank['bankid']);
        
        if(isFault($resulta)) {
            showError("Bank ".$bank['bankid']
                    .",Kunde ".$customer['customerid']
                    .": ".$resulta[0]['faultString']);
            exit;
        }
	if (count($resulta['account'])!=0)
	  {
	    foreach($resulta['account'] as $account) {
	      // put account into table
	      $db = &new DBAccess;
	      $sql = "SELECT * "
		."FROM ".$cf_db_prefix."kindofcustomer "
		."WHERE customerart='".$customer['kindofcustomer']."' ";
	      $db->query($sql);
	      
	      $kindofcustomer = "unbekannt";
	      if($db->errno != 0) {
                exit;
	      }
	      elseif($db->next_record()) {
                $kindofcustomer = $db->Record['custart_text'];
	      }
	      $accountlist[]= array(
				    'bankname'       => $bank['bankname'],
				    'bankid'         => $bank['bankid'],
				    'customername'   => $customer['customername'],
				    'forename'       => $customer['forename'],
				    'title'          => $customer['title'],
				    'kindofcustomer' => $kindofcustomer,
				    'accountid'      => $account['accountid'],
				    'customerid'     => $customer['customerid']);
	    }
	  }
    }
}

// display table sorted by current sort criteria
usort($accountlist, cmp);

$current_koc = '';
foreach($accountlist as $line) {
    if($current_koc != $line['kindofcustomer']) {
        if($current_koc != '')
            print("</table>\n");
        print("<h2>".$line['kindofcustomer']."</h2>\n");
        print("<table>\n");
        print("<tr><th>Kontoinhaber</th><th>Bankleitzahl</th><th>Kontonummer</th></tr>\n");
        $current_koc = $line['kindofcustomer'];
    }
    $name=$line['customername'];
    if($line['title'] != "")
        $name .= ','.$line['title']." ".$line['forename'];
    elseif($line['forename'] != "")
        $name .= ','.$line['forename'];
    $name .= " (".$line['customerid'].")";
    print("<tr><td>".$name."</td><td>".$line['bankid']."</td><td>".$line['accountid']."</td></tr>\n");
}
print("</table>\n");

require_once("../../template/system_foot.php");

/**
 * compare function
 */
function cmp($a, $b)
{
   if ($a['kindofcustomer'] == $b['kindofcustomer']) {
       if($a['customername'] == $b['customername']) {
           if($a['accountid'] == $b['accountid']) {
               return 0;
           }
           return ($a['accountid'] < $b['accountid']) ? -1 : 1;
       }
       return ($a['customername'] < $b['customername']) ? -1 : 1;
   }
   return ($a['kindofcustomer'] < $b['kindofcustomer']) ? -1 : 1;
}

//show errormessage            
function showError($message) {
    echo <<<END
<p><b>Fehler bei der Ausgabe der Kontenliste</b></p>

<p><b>Ursache: </b>$message</p>
</body>
</html>
END;
}
?>