<?php
/**
 * Creates standing orders.
 */

chdir("../user/ui_std");
require_once("../usgn_config.php");
require_once("$minsoft_path/user/$cf_local_interface/usli_user.php");
require_once("$minsoft_path/utility/utgn_fault.php");

// log in as user and get a security id
$userLi = &new UserLi;
$scramble = md5($_GET['password']);
$userid = $_GET['user'];
$result = $userLi->login(1, $userid, $scramble);

// error handling
if(isFault($result)) {
    showError($result[0]['faultString']);
    exit;
}

$secId = $result[1];

chdir("../../minba/ui_std");
require_once("../bagn_config.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_standingorder.php");

// transfer the money
$standingOrderLi = &new StandingOrderLi;

$amount = $_GET['amount'];
if(isset($_GET['number']))
    $amount *= $_GET['number'];

$params = array(
    "remitteraccountid" => $_GET['fromaccount'],
    "remitterbankid"    => $_GET['frombank'],
    "payeeaccountid"    => $_GET['toaccount'],
    "payeebankid"       => $_GET['tobank'],
    "payeename"         => $_GET['toowner'],
    "customerid"        => $_GET['user'],
    "currencyid"        => $_GET['currency'],
    "amount"            => $amount,
    "purpose"           => $_GET['purpose'],
    "period"            => $_GET['period'],
    "time"              => $_GET['time'],
    "lastexecuted"      => "0",
    "nextexecution"     => time()
);

$result = $standingOrderLi->create($secId, 1, $params);

// handle transfer errors
if(isFault($result)) {
    showError($result[0]['faultString']);
    exit;
}

if(isset($_GET['jump'])) {
    // jump to a page supplied by the user
    $jump = $_GET['jump'];
    $user = $_GET['user'];
    $purpose = $_GET['purpose'];
    $currency = $_GET['currency'];
    $amount = $_GET['amount'];
echo <<<END
<html>
<head>
   <title>Weiterleitung</title>
  <meta http-equiv="refresh" content="0; URL={$jump}?user={$user}&amp;purpose={$purpose}&amp;currency={$currency}&amp;amount={$amount}">
</head>
<body>
  <p>Wenn Sie nicht weitergeleitet werde, dann klicken sie bitte
  <a href="$jump">HIER</a></p>
</html>
END;
}
else {
    // or show a thank page
    echo <<<END
<html>
<head>
  <title>Vielen Dank</title>
</head>
<body>
  <h1>Vielen Dank</h1>
  <p>Vielen Dank fr Ihren Auftrag. Bitte beehren Sie uns bald wieder.</p>
</html>
END;
END;
}

function showError($message) {
    echo <<<END
<html>
<head>
<title>berweisung</title>
</head>
<body>
<p><b>Der Dauerauftrag konnte leider nicht angelegt werden</b></p>

<p><b>Ursache: </b>$message</p>
</body>
</html>
END;
}
?>