<?php
/*
Transfers money from one account to another. e.g. for building a shop.
You may or may not specify a number of pieces "number" that is
multilied by the amount.

Fields may be defined as hidden with fixed value or as input fields as
needed.

After successful transfer, a html page is executed given by "jump". Get
parameters are supplied with user, purpose, currency and amount.

See the template below to find out how to use this script.

<form action="http://diobank.ymir.de/external/transfer.php" method="get">
    <input type="hidden" name="toaccount" value="*** your accountid here ***">
    <input type="hidden" name="tobank"    value="*** your bankid here ***"   >
    <input type="hidden" name="toowner"   value="*** your owner here ***"    >
    <input type="hidden" name="purpose"   value="*** your purpose here ***"  >
    <input type="hidden" name="currency"  value="*** your currency here ***" >
    <input type="hidden" name="amount"    value="*** your amount here ***"   >
    <input type="hidden" name="jump"      value="*** next html-address ***"  >
    <table>
    <!-- <tr><td>Anzahl:</td><td><input type="text" size="8" name="number"></td></tr> -->
    <tr><td>Kunden-Id:</td><td><input type="text" size="8" name="user"></td></tr>
    <tr><td>Passwort:</td><td><input type="password" size="8" name="password"></td></tr>
    <tr><td>Kontonummer:</td><td><input type="text" size="8" name="fromaccount"></td></tr>
    <tr><td>Bankleitzahl:</td><td><input type=text" size="10" value="10" name="frombank"></td></tr>
    <tr><td colspan="2" align="center"><input type="submit" value="Bezahlen"></td></tr>
    </table>
</form>
*/

chdir("../user/ui_std");
require_once("../usgn_config.php");
require_once("$minsoft_path/user/$cf_local_interface/usli_user.php");
require_once("$minsoft_path/utility/utgn_fault.php");

// log in as user and get a security id
$userLi = &new UserLi;
$scramble = md5($_GET['password']);
$userid = $_GET['user'];
$result = $userLi->login(1, $userid, $scramble);

// error handling
if(isFault($result)) {
    showError($result[0]['faultString']);
    exit;
}

$secId = $result[1];

chdir("../../minba/ui_std");
require_once("../bagn_config.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_account.php");

// transfer the money
$accountLi = &new AccountLi;

$amount = $_GET['amount'];
if(isset($_GET['number']))
    $amount *= $_GET['number'];

$params = array(
    "remitteraccountid"     => $_GET['fromaccount'],
    "remitterbankid"        => $_GET['frombank'],
    "payeeaccountid"        => $_GET['toaccount'],
    "payeebankid"           => $_GET['tobank'],
    "accountowner"          => $_GET['user'],
    "payeeaccountowner" => "",
    "accountcurrency"       => $_GET['currency'],
    "amount"                => $amount,
    "purpose"               => $_GET['purpose']
);

$result = $accountLi->transfer_process($secId, 1, $params);
// handle transfer errors
if(isFault($result)) {
    showError($result[0]['faultString']);
    exit;
}

if(isset($_GET['jump'])) {
    // jump to a page supplied by the user
    $jump = $_GET['jump'];
    $user = $_GET['user'];
    $purpose = $_GET['purpose'];
    $currency = $_GET['currency'];
    $amount = $_GET['amount'];
echo <<<END
<html>
<head>
   <title>Weiterleitung</title>
  <meta http-equiv="refresh" content="0; URL={$jump}?user={$user}&amp;purpose={$purpose}&amp;currency={$currency}&amp;amount={$amount}">
</head>
<body>
  <p>Wenn Sie nicht weitergeleitet werde, dann klicken sie bitte
  <a href="$jump">HIER</a></p>
</html>
END;
}
else {
    // or show a thank page
    echo <<<END
<html>
<head>
  <title>Vielen Dank</title>
</head>
<body>
  <h1>Vielen Dank</h1>
  <p>Vielen Dank fr Ihren Einkauf. Bitte beehren Sie uns bald wieder.</p>
</html>
END;
END;
}

function showError($message) {
    echo <<<END
<html>
<head>
<title>berweisung</title>
</head>
<body>
<p><b>Die berweisung konnte leider nicht durchgefhrt werden</b></p>

<p><b>Ursache: </b>$message</p>
</body>
</html>
END;
}
?>