<?php
/**
 * MiNBank production: upgrade
 *
 * $Source: /cvsroot/minbank/minba/migration.php,v $
 * $Author: eltres $
 * $Date: 2007/01/21 03:40:42 $
 * $Revision: 1.13 $
 */
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
       "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>MiNBank Migration Version 1.4.1</title>
</head>
<body>
<h1>MiNBank Migration Version 1.4.1</h1>

<?php

require_once('phplib/db_mysql.inc');
require_once('minba/bagn_config.php');
require_once($minsoft_path.'/utility/utgn_fault.php');
require_once($minsoft_path.'/utility/utgn_message.php');
require_once($minsoft_path.'/utility/utgn_config.php');
require_once($minsoft_path.'/utility/utdb_access.php');

$minsoft_path = realpath(".");
$minsoftInitFile = "utility/utgn_config.php";
$minbaInitFile = "minba/bagn_config.php";
$userInitFile = "user/usgn_config.php";

print("<h1>Migration auf Version 1.4.0</h1>\n");

global $db;
$db = &new DBAccess();
$sql = 'SELECT mbversion FROM '.$utcv_db_prefix.'countryeconomy';
$db->query($sql);
if($db->errno != 0) {
    $error = $db->getError();
    print($error[0]['faultString'].'<br>');
}
else {
    $db->next_record();
    $current_version = $db->Record['mbversion'];
    echo "-- current version is ".$current_version."<br />\n";
    if($current_version < '0100400')
        migrate_V0100300_V0100400();
    if($current_version < "0100401")
        migrate_V0100400_V0100401();
    if($current_version < "0100500")
        migrate_V0100400_V0100500();
        
    print("<h2>Migration erfolgreich beendet</h2>");
}

/**
 * Migration from version 1.3.x to 1.4.0
 */
function migrate_V0100300_V0100400() {
    global $db;
    global $minsoftInitFile;
    global $minsoft_path;
    global $utcv_db_prefix;

    echo "<h2>Migration from 1.3.0 to 1.4.0</h2>\n";

echo <<<END
    <p><b>ACHTUNG: Die Version 1.4.0 enthlt diverse Erweiterungen der head-
    und css-Dateien im Verzeichnis template. Diese werden mit der Migrationsversion
    nicht ausgeliefert, da sie nicht automatisch eingefgt werden knnen. Bitte
    gleichen Sie diese Dateien von Hand ab.</b></p>
END;

    print("-- add technical user entries in utgn_config.php<br />\n");
    config_append($minsoftInitFile, 
            "    // Name and password of technical user for batch function\n"
            ."    \$utcv_technicaluser = 'technical';\n"
            ."    \$utcv_technicalpw = 'minbabatch';\n");
    
    print("-- insert technical user into user table<br />\n");
    $sql = "INSERT INTO {$utcv_db_prefix}user VALUES ('technical', 'Technical User', md5('minbabatch'),'', 32)";
    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());

    echo "-- create standing order table<br />\n";
    
    $sql = "CREATE TABLE {$utcv_db_prefix}standingorder (".
        "soid int NOT NULL auto_increment,".
        "remitterbankid varchar(10) NOT NULL,".
        "remitteraccountid int NOT NULL,".
        "payeebankid varchar(10) NOT NULL,".
        "payeeaccountid int NOT NULL,".
        "customerid varchar(8) NOT NULL,".
        "purpose varchar(50) NOT NULL,".
        "currencyid varchar(5) NOT NULL,".
        "amount decimal(15,2) NOT NULL,".
        "payeename varchar(50) NOT NULL,".
        "period smallint NOT NULL,".
        "time smallint NOT NULL,".
        "nextexecution int NOT NULL, ".
        "lastexecuted int NOT NULL, ".
        "PRIMARY KEY  (soid)".
        ") $utcv_db_create_extension;";

    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
    
    echo "-- add new field accountname to table account<br />\n";
    
    $sql = "ALTER TABLE ".$utcv_db_prefix.account." "
            ."ADD accountname varchar(50) NOT NULL";

    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
    
    echo "-- change version to 1.4.0<br />";
        
    $sql = "UPDATE ".$utcv_db_prefix."countryeconomy "
           ."SET mbversion='0100400'";
           
    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
}

/**
 * Migration from version 1.4.0 to 1.4.1
 */
function migrate_V0100400_V0100401() {
    global $db;
    global $minsoftInitFile;
    global $minsoft_path;
    global $utcv_db_prefix;

    echo "<h2>Migration from 1.4.0 to 1.4.1</h2>\n";
    
    //---------------------------------------------------------    
    echo "-- change version to 1.4.1<br />";
        
    $sql = "UPDATE ".$utcv_db_prefix."countryeconomy "
           ."SET mbversion='0100401'";
           
    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
}

/**
 * Migration from version 1.4.x to 1.5.0
 */
function migrate_V0100400_V0100500() {
    global $db;
    global $minsoftInitFile;
    global $minsoft_path;
    global $utcv_db_prefix;
    
    echo "<h2>Migration from 1.4.x to 1.5.0</h2>\n";

    echo "<p><b>Bitte richten Sie jede Bank als Kunden ihrer Bank ein, "
         ." erffnen Sie ein Konto fr die Bank und tragen Sie das Konto "
         ."in den Bankparametern ein.</b></p>";
         
    echo '-- add new fields to bank table<br />';
    $sql = "ALTER TABLE ".$utcv_db_prefix."bank"
        ." ADD timedeposit1name VARCHAR(30) NOT NULL,"
        ." ADD timedeposit1period INT NOT NULL,"
        ." ADD timedeposit1interest DECIMAL(5,2) NOT NULL,"
        ." ADD timedeposit2name VARCHAR(30) NOT NULL,"
        ." ADD timedeposit2period INT NOT NULL,"
        ." ADD timedeposit2interest DECIMAL(5,2) NOT NULL,"
        ." ADD timedeposit3name VARCHAR(30) NOT NULL,"
        ." ADD timedeposit3period INT NOT NULL,"
        ." ADD timedeposit3interest DECIMAL(5,2) NOT NULL,"
        ." ADD timedeposit4name VARCHAR(30) NOT NULL,"
        ." ADD timedeposit4period INT NOT NULL,"
        ." ADD timedeposit4interest DECIMAL(5,2) NOT NULL,"
        ." ADD locked SMALLINT NOT NULL,"
        ." ADD deleted SMALLINT NOT NULL,"
        ." CHANGE bankbookinterest overdraftinterest DECIMAL(5,2) NOT NULL,"
        ." CHANGE bankaccountid bankaccountid INT NOT NULL DEFAULT '0'";

        $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
    
    echo '-- add new fields to account table<br />';

    $sql = "ALTER TABLE ".$utcv_db_prefix."account "
        ."ADD createdate INT NOT NULL,"
        ."ADD deletedate INT NOT NULL,"
        ."ADD lastfeedate INT NOT NULL,"
        ."ADD changedate INT NOT NULL,"
        ."ADD locked SMALLINT NOT NULL";
           
        $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
        
    echo '-- add new fields to standing order table<br />';

    $sql = "ALTER TABLE ".$utcv_db_prefix."standingorder "
        ."ADD createdate INT NOT NULL,"
        ."ADD deletedate INT NOT NULL,"
        ."ADD changedate INT NOT NULL,"
        ."ADD deleted SMALLINT NOT NULL";
           
        $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
        
    echo '-- add new fields to customer table<br />';

    $sql = "ALTER TABLE ".$utcv_db_prefix."customer "
        ."ADD forename VARCHAR(30) NOT NULL,"
        ."ADD title VARCHAR(20) NOT NULL,"
        ."ADD createdate INT NOT NULL,"
        ."ADD deletedate INT NOT NULL,"
        ."ADD changedate INT NOT NULL,"
        ."ADD locked SMALLINT NOT NULL";
           
        $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
        
    echo '-- create new time deposit table<br />';    
    $sql = "CREATE TABLE ".$utcv_db_prefix."timedeposits ("
        ."timedepositid INT NOT NULL AUTO_INCREMENT,"
        ."bankid INT NOT NULL,"
        ."sequence SMALLINT NOT NULL,"
        ."name VARCHAR(50) NOT NULL,"
        ."period SMALLINT NOT NULL,"
        ."interestrate DECIMAL(5,2) NOT NULL,"
        ."PRIMARY KEY (timedepositid),"
        ."INDEX (bankid)"
        .") ".$utcv_db_create_extension;   

    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());    
}

    //---------------------------------------------------------    
    echo "-- create tax table<br />";
    

$sql="CREATE TABLE {$utcv_db_prefix}tax (
  `taxid` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `type` int(11) NOT NULL default '0',
  `who` int(11) NOT NULL default '0',
  `transferfrom` int(11) NOT NULL default '0',
  `lastexecute` int(11) NOT NULL default '0',
  `period` int(11) NOT NULL default '0',
  `time` int(11) NOT NULL default '0',
  `percent` double NOT NULL default '0',
  `fixed` double NOT NULL default '0',
  `free` double NOT NULL default '0',
  `cut` double NOT NULL default '0',
  `reduceforfree` smallint(6) NOT NULL default '0',
  `taxaccount` int(11) NOT NULL default '0',
  `taxaccbic` int(11) NOT NULL default '0',
  `state` varchar(30) NOT NULL default '',
  `city` varchar(30) NOT NULL default '',
  `deleted` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`taxid`) )$utcv_db_create_extension
";


    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
    
    $db->free();


    //---------------------------------------------------------    
    echo "-- create tax bill table<br />";
    
$sql="CREATE TABLE  {$utcv_db_prefix}taxbill (
  `taxid` int(11) NOT NULL default '0',
  `customerid` varchar(10) NOT NULL default '',
  `amount` double NOT NULL default '0',
  `date` int(11) NOT NULL default '0',
  `paid` tinyint(4) NOT NULL default '0'
) $utcv_db_create_extension";
        

    $db->query($sql);
    
    if($db->errno != 0)
        abort($db->getError());
    
    $db->free();
    

// *** utility functions for migration ***

// append text to config file
function config_append($filename, $text) {

    if(! is_writable($filename))
    {
        echo "<b>Problem:</b> Die Datei $filename konnte nicht geffnet werden.<br />\n";
        echo "Bitte prfen Sie, ob Schreibrechte auf die Datei bestehen\n";
        exit;
    }

    // read old contents
    $old = file($filename);
    
    // remove last end of php mark
    for($i=sizeof($old); $i>=0; $i--) {
        if(strpos($old[$i], "?>") !== false) {
            $old = str_replace("?>", "", $old);
            break;
        }
    }
        
    // write new contents into file
    $fp = @fopen($filename, "w");
    for($i=0; $i<sizeof($old); $i++)
        fputs($fp, $old[$i]);
        
    fputs($fp, $text);
    fputs($fp, "?>\n");
    fclose($fp);
}

function abort($fault)
{
    echo "<p>ERROR IN INSTALLATION !</p>";
    die("<p>{$fault[0]['faultString']}<p>");
}    

?>
</body>
</html>   