<?php
require_once("../bagn_config.php");
require_once("$minsoft_path/utility/utxr_client.php");

// local interface belonging to class account
class AccountLi
{    

    //*************      public Account create,delete,read,update,extract    *****
    function create($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.create", array($secId,$lang,$account));
    }
    
    function read($secId,$lang,$accountid,$bankid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;

        return $this->ba_call("Account.read", array($secId,$lang,$accountid,$bankid));
    }
    
    function delete($secId,$lang,$accountid,$bankid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.delete", array($secId,$lang,$accountid,$bankid));
    }
    
    
    function account_extract($secId,$lang,$accountid,$bankid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.account_extract", 
                array($secId,$lang,$accountid,$bankid));
    }
    
    function account_authority($secId,$lang,$accountid,$bankid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        return $this->ba_call("Account.account_authority", 
                array($secId,$lang,$accountid,$bankid));
    }
    
    function account_authority_delete($secId,$lang,$accountid,
            $accountowner,$bankid,$deputeeid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        return $this->ba_call("Account.account_authority_delete", 
                array($secId,$lang,$accountid,$accountowner,$bankid,$deputeeid));
    }

    function account_authority_new($secId,$lang,$accountid,
            $accountowner,$bankid,$deputeeid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        return $this->ba_call("Account.account_authority_new", 
                array($secId,$lang,$accountid,$accountowner,$bankid,$deputeeid));
    }
    
    // ************* public account transfer methods*****
    function transfer_process($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.transfer_process", 
                        array($secId,$lang,$account));
    }

    // ************* protected account transfer methods*****
    function transfer_remittee($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.transfer_remittee", 
                        array($secId,$lang,$account));
    }
    
    function transfer_remitter($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        
        return $this->ba_call("Account.transfer_remitter", 
                        array($secId,$lang,$account));
    }
    
    function update_remitter($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.update_remitter", 
                        array($secId,$lang,$account));
    }
    
    
    function transfer($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;

        
        return $this->ba_call("Account.transfer", 
                        array($secId,$lang,$account));
    }
    
    function transfer_rollback($secId,$lang,$account)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.transfer_rollback", 
                        array($secId,$lang,$account));
    }
    
    function get_accountowner($secId,$lang,$accountid,$bankid)
    {
        global $cf_db_prefix;
        $cf_lang = $lang;
        
        return $this->ba_call("Account.get_accountowner", 
                        array($secId,$lang,$accountid,$bankid));
    }
    
    function account_create_money($secId,$lang,$accountparams)
    {
        
        return $this->ba_call("Account.create_money", array($secId,$lang,$accountparams));
    }
    
    function account_eliminate_money($secId,$lang,$accountparams)
    {
        
        return $this->ba_call("Account.eliminate_money", array($secId,$lang,$accountparams));
    }
    

    // ********* private help function ******
    function ba_call($function, $params)
    {
        // define globals
        global $cf_host, $cf_path, $cf_port;
                
        $client = new UTXRClient;
        // set remote interface
        $client->setServer($cf_host, $cf_path, $cf_port);
        // call remote interface
        return $client->call($function, $params);
    }
}
?>