<?php

// This module is the server side xml-rpc interface.
// It calls the catch function of the xml-rpc server utilities

require_once ("../bagn_config.php");
require_once("$minsoft_path/utility/utxr_server.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$appl_path/bo/babo_bank.php");
require_once("$appl_path/bo/babo_customer.php");
require_once("$appl_path/bo/babo_centralbank.php");
require_once("$appl_path/bo/babo_account.php");
require_once("$appl_path/bo/babo_standingorder.php");

// Im bergebenen Array gibt es folgende Parameter:
// Busines Objekt Name
// Business Objekt Funktion
// spezifische xmlrpc Funktion
utxr_catch(
    array ("Economic.economic_read_params", "Economic.economic_update_params",
        "Centralbank.getbanklist","Centralbank.check_roles",
        "Centralbank.centralbank_read_params","Centralbank.centralbank_update_params",    
        "Customer.create","Customer.get_customer_art",
        "Customer.delete","Customer.read","Customer.update","Bank.customer_list",
        "Bank.bank_create","Bank.bank_update","Bank.bank_read","Bank.bank_delete",
        "Bank.bank_read_params","Bank.bank_update_params",
        "Customer.customer_deputee",
        "Customer.customer_deputee_delete","Customer.customer_deputee_new",
        "Customer.deputee_customer",
        "Account.create",
        "Account.delete","Account.read","Account.update","Customer.account_list",
        "Account.account_extract","Account.account_authority",
        "Account.account_authority_delete","Account.account_authority_new",
        "Account.transfer_process",
        "Account.transfer_remitter", "Account.transfer_remittee",
        "Account.transfer","Account.update_remitter","Account.transfer_rollback","Account.get_accountowner",
        "Account.account_create_money","Account.account_eliminate_money",
        "Account.standingorder_list",
        "Standingorder.create", "Standingorder.delete", "Standingorder.execute",
        "Standingorder.read", "Standingorder.update"
        ),
    array ("economic_read_params","economic_update_params",
        "centralbank_getbanklist","centralbank_check_roles",
        "centralbank_read_params","centralbank_update_params",
        "customer_create","get_customer_art",
         "customer_delete","customer_read","customer_update","customer_list",
         "bank_create","bank_update","bank_read","bank_delete",
         "bank_update_params","bank_read_params",
         "customer_deputee","customer_deputee_delete","customer_deputee_new",
         "deputee_customer",
         "account_create",
         "account_delete","account_read","account_update","account_list",
         "account_extract","account_authority",
         "account_authority_delete","account_authority_new",
         "transfer_process",
         "transfer_remitter","transfer_remittee","transfer","update_remitter",
         "transfer_rollback","get_accountowner",
         "account_create_money","account_eliminate_money",
         "account_standingorder_list",
         "standingorder_create", "standingorder_delete", "standingorder_execute",
         "standingorder_read", "standingorder_update"
         ));
exit(0);
        
// interface functions to the business object
// Die Parameter entsprechen der Vorschrift von xmlrpc
// Die Daten befinden sich in "app_data"

function economic_read_params($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_economic = &new Economic;
    
    return $new_economic->economic_read_params($params[0],$params[1]);
}

function economic_update_params($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_economic = &new Economic;
    
    return $new_economic->economic_update_params($params[0],$params[1],$params[2]);
}

function centralbank_getbanklist($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $centralbank = &new Centralbank;
    // Die Funktion "role" im Objekt "user" wird aufgerufen
    return $centralbank->getbanklist($params[0],$params[1]);
}

function centralbank_check_roles($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $centralbank = &new Centralbank;
    // Die Funktion "role" im Objekt "user" wird aufgerufen
    return $centralbank->check_roles($params[0],$params[1]);
}

function centralbank_read_params($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_centralbank = &new Centralbank;
    
    // Die Funktion "bank_read" im Objekt "Bank" wird aufgerufen
    return $new_centralbank->centralbank_read_params($params[0],$params[1]);
}

function centralbank_update_params($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_centralbank = &new Centralbank;
    
    // Die Funktion "bank_update" im Objekt "Bank" wird aufgerufen
    return $new_centralbank->centralbank_update_params($params[0],$params[1],$params[2]);
}



function customer_create($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    
    // Die Funktion "create" im Objekt "customer" wird aufgerufen
    return $new_customer->create($params[0], $params[1],$params[2]);
}

function get_customer_art($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    
    return $new_customer->get_customer_art($params[0], $params[1]);
}

function customer_delete($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    
    // Die Funktion "delete" im Objekt "customer" wird aufgerufen
    return $new_customer->delete($params[0],$params[1],$params[2],$params[3]);
}

function customer_update($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    
    // Die Funktion "update" im Objekt "customer" wird aufgerufen
    return $new_customer->update($params[0], $params[1],$params[2]);
}

function customer_read($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    
    // Die Funktion "read" im Objekt "customer" wird aufgerufen
    return $new_customer->read($params[0], $params[1],$params[2],$params[3]);
}

function customer_deputee($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    return $new_customer->customer_deputee($params[0],$params[1],$params[2],$params[3]);
}

function deputee_customer($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    return $new_customer->deputee_customer($params[0],$params[1],$params[2],$params[3]);
}

function customer_deputee_delete($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    return $new_customer->customer_deputee_delete($params[0],$params[1],$params[2],
    $params[3],$params[4]);
}
function customer_deputee_new($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    return $new_customer->customer_deputee_new($params[0],$params[1],
    $params[2],$params[3],$params[4]);
}

function customer_list($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_bank = &new Bank;
    
    // Die Funktion "customer_list" im Objekt "customer" wird aufgerufen
    return $new_bank->customer_list($params[0],$params[1],$params[2]);
}

function bank_create($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_bank = &new Bank;
    
    // Die Funktion "bank_read" im Objekt "Bank" wird aufgerufen
    return $new_bank->bank_create($params[0],$params[1],$params[2]);
}


function bank_update($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_bank = &new Bank;
    
    // Die Funktion "bank_update" im Objekt "Bank" wird aufgerufen
    return $new_bank->bank_update($params[0],$params[1],$params[2]);
}


function bank_delete($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_bank = &new Bank;
    
    // Die Funktion "bank_delete" im Objekt "Bank" wird aufgerufen
    return $new_bank->bank_delete($params[0],$params[1],$params[2]);
}

function bank_read_params($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_bank = &new Bank;
    
    // Die Funktion "bank_read" im Objekt "Bank" wird aufgerufen
    return $new_bank->bank_read_params($params[0],$params[1],$params[2]);
}

function bank_update_params($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_bank = &new Bank;
    
    // Die Funktion "bank_update" im Objekt "Bank" wird aufgerufen
    return $new_bank->bank_update_params($params[0],$params[1],$params[2]);
}

function account_create($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    
    // Die Funktion "create" im Objekt "customer" wird aufgerufen
    return $new_account->create($params[0], $params[1],$params[2]);
}

function account_delete($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "delete" im Objekt "customer" wird aufgerufen
    return $new_account->delete($params[0], $params[1],$params[2],$params[3]);
}

function account_update($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "update" im Objekt "customer" wird aufgerufen
    return $new_account->update($params[0], $params[1],$params[2]);
}

function account_read($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "read" im Objekt "customer" wird aufgerufen
    return $new_account->read($params[0], $params[1],$params[2],$params[3]);
}

function account_extract($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "extract" im Objekt "Customer" wird aufgerufen
    return $new_account->account_extract($params[0],$params[1],$params[2],$params[3]);
}

function account_authority($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "extract" im Objekt "Customer" wird aufgerufen
    return $new_account->account_authority($params[0],$params[1],$params[2],$params[3]);
}
function account_authority_delete($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "extract" im Objekt "Customer" wird aufgerufen
    return $new_account->account_authority_delete($params[0],$params[1],$params[2],
    $params[3],$params[4],$params[5]);
}
function account_authority_new($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "extract" im Objekt "Customer" wird aufgerufen
    return $new_account->account_authority_new($params[0],$params[1],
    $params[2],$params[3],$params[4],$params[5]);
}
function account_list($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_customer = &new Customer;
    // Die Funktion "customer_list" im Objekt "customer" wird aufgerufen
    return $new_customer->account_list($params[0],$params[1],$params[2],$params[3]);
}

function transfer_process($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "transfer" im Objekt "Account" wird aufgerufen
    return $new_account->transfer_process($params[0],$params[1],$params[2]);
}

function transfer_remitter($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "transfer" im Objekt "Account" wird aufgerufen
    return $new_account->transfer_remitter($params[0],$params[1],$params[2]);
}

function transfer_remittee($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "transfer" im Objekt "Account" wird aufgerufen
    return $new_account->transfer_remittee($params[0],$params[1],$params[2]);
}

function transfer($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "transfer" im Objekt "Account" wird aufgerufen
    return $new_account->transfer($params[0],$params[1],$params[2]);
}

function update_remitter($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "transfer" im Objekt "Account" wird aufgerufen
    return $new_account->update_remitter($params[0],$params[1],$params[2]);
}

function transfer_rollback($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    // Die Funktion "transfer" im Objekt "Account" wird aufgerufen
    return $new_account->transfer_rollback($params[0],$params[1],$params[2]);
}

function get_accountowner($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    return $new_account->get_accountowner($params[0],$params[1],$params[2],$params[3]);
}

function account_create_money($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    
    // Die Funktion "create_money" im Objekt "Account" wird aufgerufen
    return $new_account->account_create_money($params[0],$params[1],$params[2]);
}


function account_eliminate_money($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    
    // Die Funktion "eliminate_money" im Objekt "Account" wird aufgerufen
    return $new_account->account_eliminate_money($params[0],$params[1],$params[2]);
}

function account_standingorder_list($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_account = &new Account;
    
    // Die Funktion "list" im Objekt "StandingOrder" wird aufgerufen
    return $new_account->list($params[0],$params[1],$params[2],$params[3]);
}

function standingorder_create($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_so = &new Standingorder;
    
    // Die Funktion "create" im Objekt "StandingOrder" wird aufgerufen
    return $new_so->create($params[0],$params[1],$params[2]);
}

function standingorder_delete($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_so = &new Standingorder;
    
    // Die Funktion "delete" im Objekt "StandingOrder" wird aufgerufen
    return $new_so->delete($params[0],$params[1],$params[2]);
}

function standingorder_execute($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_so = &new Standingorder;
    
    // Die Funktion "execute" im Objekt "StandingOrder" wird aufgerufen
    return $new_so->execute($params[0]);
}

function standingorder_read($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_so = &new Standingorder;
    
    // Die Funktion "read" im Objekt "StandingOrder" wird aufgerufen
    return $new_so->read($params[0],$params[1],$params[2]);
}

function standingorder_update($method_name, $params, $app_data)
{
    // Erzeugen eines Business Objekts
    $new_so = &new Standingorder;
    
    // Die Funktion "update" im Objekt "StandingOrder" wird aufgerufen
    return $new_so->update($params[0],$params[1],$params[2]);
}

?>