<?php
/**
 * MiNBank user interface: account
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_account.php,v $
 * $Author: mboller $
 * $Date: 2006/01/06 19:19:01 $
 * $Revision: 1.7 $
 */

session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface of a business object
require_once("$minsoft_path/minba/$cf_local_interface/bali_account.php");
require_once("$baui_form_path/bafo_account.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");
 

//**************  main ******************************************
// check submit and radio buttons
if(isset($_POST["bafv_submit_back"]))
{
    require_once("baui_accountlist.php"); 
    exit;
}
if(isset($_POST["bafv_submit_create"]))
{
    process_account_create();
    exit;
}
if(isset($_POST["bafv_submit_update"]))
{
    $accountid = $_POST["bafv_accountid"];
    process_account_update($accountid);
    exit;
}
if($_GET["submit"]=="bafv_submit_bvdel")
{
    if(isset($_GET["bafv_deputeeid"]))
    {
        $deputeeid = $_GET["bafv_deputeeid"];
        process_account_authority_delete($deputeeid);
        exit;
    }
    else
    {
        $bafv_msg = getMessage("2045");
        process_account_authority($_SESSION['selected_accountid']);
        exit;
    }    
}
if(isset($_POST["bafv_submit_bvnew"]))
{
    $deputeeid = $_POST["bafv_deputeeid_new"];
    if($deputeeid == "")
    {
        $bafv_msg = getMessage("2046");
        process_account_authority($_SESSION['selected_accountid']);
        exit;
    }
    else
    {
        process_account_authority_new($deputeeid);
        exit;
    }
}

/**
 * Creates an account.
 */
function process_account_create()
{
    global $cf_lang;
    global $girokonto; // global constant describing girokonto
    global $currency;  // global constant describing the currency
    
    if(!isset($_POST["bafv_submit_create"]))
    {
        if($_SESSION['us_id'] != $_SESSION['selected_customer'])
        {
            $accountowner = $_SESSION['selected_customer'];
        }
        else
        {
            $accountowner = $_SESSION['us_id'];
        }
        $account = array(
            'kindofaccount' => $girokonto,
            'accountname' => "",
            'accountcurrency' => $currency,
            'accountowner' => $accountowner,
            'bankid' => $_SESSION['baui_bankid']);
            display_account_create_form($message, $account);
        exit;
    }    
    
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
                            
    // user input is checked in the Customer business object    
        
    $account =  array(
            'accountid' => $_POST["bafv_accountid"],
            'accountname' => $_POST["bafv_accountname"], 
            'kindofaccount' => $girokonto,
            'accountowner' =>$_POST["bafv_accountowner"],
            'accountcurrency' => $_POST["bafv_accountcurrency"],
            'bankid' => $_SESSION['baui_bankid']);
            
    $result = $li->create($_SESSION['us_secId'],$lang,$account);                                          
                                             
    // error handling
    if(isFault($result))
    {
        $message = $result[0]["faultString"];
        display_account_create_form($message,$account);    
    }
    // clear input fileds after successful action
    else
    {
        $message = getMessage("2041",$result);
        display_account_create_form($message,$account);
    }    
}

/**
 * Updates an account.
 */
function process_account_update($accountid)
{
    global $cf_lang;
    global $girokonto; // global constant describing girokonto
    global $currency;  // global constant describing the currency
    
    if(!isset($_POST["bafv_submit_update"]))
    {
        if($_SESSION['us_id'] != $_SESSION['selected_customer'])
        {
            $accountowner = $_SESSION['selected_customer'];
        }
        else
        {
            $accountowner = $_SESSION['us_id'];
        }
        
        $li = &new AccountLi;
        $lang = $cf_lang;

        $result = $li->read($_SESSION['us_secId'],$lang,$accountid,$_SESSION['baui_bankid']);                                                                                                  
                                                 
        // error handling
        if(isFault($result))
        {
            $message = $result[0]["faultString"];
            display_account_update_form($message,$account);
            exit;  
        }

        display_account_update_form($message, $result);
        exit;
    }    
    
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
                            
    // user input is checked in the Customer business object    
        
    $account =  array(
            'accountid' => $_POST["bafv_accountid"],
            'accountname' => $_POST["bafv_accountname"], 
            'kindofaccount' => $_POST["bafv_kindofaccount"],
            'accountowner' =>$_POST["bafv_accountowner"],
            'accountcurrency' => $_POST["bafv_accountcurrency"],
            'bankid' => $_SESSION['baui_bankid']);
            
    $result = $li->update($_SESSION['us_secId'],$lang,$account);                                          
                                             
    // error handling
    if(isFault($result))
    {
        $message = $result[0]["faultString"];
        display_account_update_form($message,$account);    
    }
    else
    {
        // show OK message
        $message = getMessage("2076",$result);
        display_account_update_form($message,$account);
    }    
}

/**
 * Reads account information.
 *
 * @param $accountid id of account to be read
 */
function process_account_read($accountid)
{  
    global $cf_lang;
     
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    
    // user input is checked in the business object    
    $result = $li->read($_SESSION['us_secId'],$lang,$accountid,$_SESSION['baui_bankid']);                                                                                                  
                                               
    // error handling
    if(isFault($result))
    {
        $message = $result[0]["faultString"];
        $account = get_empty_account();
        display_account_read_form($message, $account);
        exit;    
    }
    if(!is_array($result))
    {
        $message = getMessage("2016");
        $account = get_empty_account();
        display_account_read_form($message, $account);
        exit;    
    }
    // display account information
    else
    {          
        $message = "";
        display_account_read_form($message,$result);
    }    
}

/**
 * Deletes an account.
 *
 * @param accountid id of account to be deleted
 */
function process_account_delete($accountid)
{  
    global $cf_lang;
    global $bafv_msg;
    global $bafv_accountid;
    
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    
    $result = $li->delete($_SESSION['us_secId'],$lang,$accountid,$_SESSION['baui_bankid']);                                          
                                             
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        
    }
    else
    {       
        $bafv_accountid = "";
    }
                         
}

/**
 * Displays transfer history of an account.
 *
 * @param $accountid account id
 */
function process_account_extract($accountid)
{  
    global $cf_lang;
    global $account;
    global $account_extract_list;
    global $bafv_msg;
    
    $inputerror = FALSE; 
    
    
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    
    // user input is checked in the business object Customer    
    if($inputerror == FALSE)
    {            
        $result = $li->account_extract($_SESSION['us_secId'],$lang,$accountid,$_SESSION['baui_bankid']);  
                                                                                                                             
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_account_extract_form();
            exit;    
        }
        // display if successfull
        else
        {
            $account_extract_list = $result;
            $bafv_msg = "";
            display_account_extract_form();
        }    
    }
}

/**
 * Displays authority information belonging to an account.
 *
 * @param $accountid account id
 */
function process_account_authority($accountid)
{  
    global $cf_lang;
    global $account;
    global $account_authority_list;
    global $bafv_msg;
    
    if($account_authority_list != NULL)
    {
        display_account_authority_form();
        exit;
    }
        
    $inputerror = FALSE; 
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    
    // user input is checked in the business object Customer    
    if($inputerror == FALSE)
    {            
        $result = $li->account_authority($_SESSION['us_secId'],$lang,$accountid,$_SESSION['baui_bankid']);  
                                                                                                                           
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_account_authority_form();
            exit;    
        }
        // display if successfull
        else
        {
            $account_authority_list = $result;
            display_account_authority_form();
        }    
    }
}

/**
 * Deletes an authority of an account
 *
 * @param $deputeeid customer id of a deputee
 */
function process_account_authority_delete($deputeeid)
{  
    global $cf_lang;
    global $bafv_msg;
    global $account_authority_list;
    
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    $result = $li->account_authority_delete($_SESSION['us_secId'],
            $lang,$_SESSION['selected_accountid'],$_SESSION['selected_customer'],$_SESSION['baui_bankid'],$deputeeid); 
                                                                                   
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        process_account_authority($_SESSION['selected_accountid']);    
    }
    else
    {
        $bafv_accountid = "";
        $bafv_deputeeid_new = "";
        $bafv_msg = "";
        process_account_authority($_SESSION['selected_accountid']);
    }        
}

/**
 * Inserts a new authority member to an account.
 *
 * @param deputeeid customer id of deputee
 */
function process_account_authority_new($deputeeid)
{  
    global $cf_lang;
    global $bafv_msg;
    global $bafv_deputeeid_new;
    global $account_authority_list;
    
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    
    $result = $li->account_authority_new($_SESSION['us_secId'],$lang,
            $_SESSION['selected_accountid'],$_SESSION['selected_customer'],$_SESSION['baui_bankid'],$deputeeid);
                                                                                              
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_account_authority_form();
        exit;
    }
    else
    {
        $bafv_accountid = "";
        $bafv_deputeeid_new = "";
        process_account_authority($_SESSION['selected_accountid']);
    }        
}

/**
 * Get an empty account array
 *
 * @return account array with empty values
 */
function get_empty_account() {
    global $girokonto;
    
    $account = array(
         'accountid' => "",
         'kindofaccount' => $girokonto,
         'accountowner' => "",
         'accountcurrency' => "",
         'accountbalance' => ""
    );
    return $account;
}

?>