<?php
/**
 * MiNBank user interface: list of accounts
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_accountlist.php,v $
 * $Author: mboller $
 * $Date: 2006/01/06 19:19:01 $
 * $Revision: 1.9 $
 */

session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface of a business objekt
require_once("$minsoft_path/minba/$cf_local_interface/bali_customer.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");
require_once("$baui_form_path/bafo_account_list.php");

// check submit and radio buttons
if(isset($_POST["bafv_submit_ktback"]))
{
    if($_SESSION['act_role'] != utrl_bankmanager)
    {
        require_once("baui_banksystem.php");
    }
    else
    {
        require_once("baui_customerlist.php");
    }
        
    exit;
}
if(isset($_POST["bafv_submit_ktneu"])) 
{ 
        require_once("baui_account.php");
           $_SESSION['act_role'] = utrl_customer;
           process_account_create();
           exit;
}

if($_GET["submit"]=="bafv_submit_ktad")
{
    require_once("baui_account.php");
    require_once("baui_standingorder.php");
    $ktad= $_GET["bafv_ktad"];

    $func = strtok($ktad,":");
    $accountid=strtok(":");
    $_SESSION['selected_accountid'] = $accountid;
    switch ($func)
    {
        case 1:
            process_account_read($accountid);
            exit;
            break;
        case 2:
            process_account_update($accountid);
            exit;
            break;
        case 3:
            process_account_delete($accountid);
            process_account_list();
            exit;
            break;
        case 4:
            require_once("baui_transfer.php");
            process_transfer($accountid);
            exit;
            break;
        case 5:
            process_account_extract($accountid);
            exit;
            break;
        case 6:
            process_account_authority($accountid);
            exit;
            break;
        case 7:
            process_standingorders("", $accountid);
            break;
        default:
              $bafv_msg = getFault("2037");
              exit;
              break;
    }
}
else
{
    process_account_list();
    
}


// read account list from business objekt Account
function process_account_list()
{
    global $cf_lang;
    global $bafv_msg;
    global $bafv_errno;
    global $accountlist;
    global $authaccountlist;
    $bafv_errno = "";
    
    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;
                            
    // customer or bankmanager?
    if($_SESSION['us_id'] != $_SESSION['selected_customer'])
    {
        $selected_userid = $_SESSION['selected_customer'];
    }
    else
    {
        $selected_userid = $_SESSION['us_id'];
    }
    $result = $li->account_list($_SESSION['us_secId'],$lang,
                            $selected_userid,$_SESSION['baui_bankid']);     
                                                                                                        
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_account_list_form();
        exit;    
    }
    $is_customer = "1";
    $rcount = count($result);
    // customer has no accounts and no authorities
    if($rcount == 0)
    {
        $val1 = '0';
        $val2 = '0';
    }
    // customer has accounts and/or authorities
    else
    {
        $n1 = $result["account"];
        $n2 = $result["auth"];
        if(is_array($result))
        {
            if (is_array($n1))
            {
                $owner = $n1;
                $val1 = count($n1);
            }
            else
            {
                $owner = NULL;
                $val1 = '0';
            }
        
            $val2 = '0';
            if($rcount > 1)
            {
                if(is_array($n2))
                {
                    $authlist = $n2;
                    $val2 = count($n2);
                }
                else
                {
                    $authlist = NULL;
                    $val2 = '0';
                }
            }
        }
        
        if($val1 == '0'&& $val2 == '0')
        {
            display_account_list_form();
            exit;
        }
        if($val1 == 1)
        {
            $kunde = $accountlist["0"];
            
        }
    }    

    if($is_customer == "0")
    {
        $bafv_errno = "2031";
        $bafv_msg = getMessage("2031");
        display_account_list_form();
        exit;
    }
    
    $count = 0;
    $act_ktart =0;
    $accountlist = NULL;
    if($owner != NULL)
    {
        foreach ($owner as $number => $konto)
        {
            foreach($konto as $name => $eigen)
            {  
                   if($name == "kindofcustomer" )
                   {
                       if($eigen != $act_ktart)
                       {
                           $act_ktart = $eigen;
                           $count = 0;
                       }
                   }
                   else
                   {
                       $accountitem[$name] = $eigen;
                }
            }
            $accountlist[$act_ktart][$count] = $accountitem;
            $count++;
        }
    }
    
    if($authlist != NULL)
    {
        $authaccountlist = NULL;
        $count = 0;
        $act_ktart =0;
        foreach ($authlist as $number => $konto)
        {
            foreach($konto as $name => $eigen)
            {  
                   if($name == "kindofcustomer" )
                   {
                       if($eigen != $act_ktart)
                       {
                           $act_ktart = $eigen;
                           $count = 0;
                       }
                   }
                   else
                   {
                       $accountitem[$name] = $eigen;
                }
            }
            $authaccountlist[$act_ktart][$count] = $accountitem;
            $count++;
        }
    }
    display_account_list_form();
}
?>