<?php
/**
 * MiNBank user interface: bank
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_bank.php,v $
 * $Author: mboller $
 * $Date: 2006/02/13 00:43:07 $
 * $Revision: 1.5 $
 */

session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface of a business objekt
require_once("$minsoft_path/minba/$cf_local_interface/bali_bank.php");
require_once("$baui_form_path/bafo_bank.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");

/************************  main **********************************/

// ceck submit and radio buttons
if(isset($_POST["bafv_submit_back"]))
{
    require_once("baui_customerlist.php");
    exit;
}

if(isset($_POST["bafv_submit_update"]))
{
    $bankid = $_POST["bafv_bankid"];
    process_bank_update_params($bankid);
    exit;
}

// update customer information
function process_bank_update_params($bankid)
{
    global $cf_lang;

    $inputerror = FALSE;

    // initialise local interface
    $li = &new BankLi;
    $lang = $cf_lang;


    if(!isset($_POST["bafv_submit_update"]))
    {

        $result = $li->bank_read_params($_SESSION['us_secId'],$lang,$bankid);
        $bankparams =$result[0];
        $message = "";

        // error handling
        if(isFault($result))
        {
            $message = $result[0]["faultString"];
            $bankparams = getEmptyBankparams();
        }
        else if(!is_array($result))
        {
            $message = getFault("2011");
            $bankparams = getEmptyBankparams();
        }

        // show customer information if valid customer
        display_bankparam_update_form($message, $bankparams);
        exit;

    }

    if($inputerror == FALSE)
    {
        $bankparams =  array(
                "bankname"               => $_POST["bafv_bankname"],
                "bankid"                 => $_POST["bafv_bankid"],
                "bankaccountid"          => $_POST["bafv_bankaccountid"],
                "accountstartfee"        => str_replace(",",".", $_POST["bafv_accountstartfee"]),
                "accountendfee"          => str_replace(",",".", $_POST["bafv_accountendfee"]),
                "girocharge"             => str_replace(",",".", $_POST["bafv_girocharge"]),
                "remittancefee"          => str_replace(",",".", $_POST["bafv_remittancefee"]),
                "standingorderfirstfee"  => str_replace(",",".", $_POST["bafv_standingorderfirstfee"]),
                "standingorderendfee"    => str_replace(",",".", $_POST["bafv_standingorderendfee"]),
                "bankwithdrawalstartfee" => str_replace(",",".", $_POST["bafv_bankwithdrawalstartfee"]),
                "bankwithdrawalendfee"   => str_replace(",",".", $_POST["bafv_bankwithdrawalendfee"]),
                "overdraftinterest"       => str_replace(",",".", $_POST["bafv_overdraftinterest"]),
                "creditfee"              => str_replace(",",".", $_POST["bafv_creditfee"]),
                "creditinterest"         => str_replace(",",".", $_POST["bafv_creditinterest"]),
                "overdraftinterest"      => str_replace(",",".", $_POST["bafv_overdraftinterest"]),
                "timedeposit1name"       => $_POST["bafv_timedeposit1name"],
                "timedeposit1period"     => str_replace(",",".", $_POST["bafv_timedeposit1period"]),
                "timedeposit1interest"   => str_replace(",",".", $_POST["bafv_timedeposit1interest"]),
                "timedeposit2name"       => $_POST["bafv_timedeposit2name"],
                "timedeposit2period"     => str_replace(",",".", $_POST["bafv_timedeposit2period"]),
                "timedeposit2interest"   => str_replace(",",".", $_POST["bafv_timedeposit2interest"]),
                "timedeposit3name"       => $_POST["bafv_timedeposit3name"],
                "timedeposit3period"     => str_replace(",",".", $_POST["bafv_timedeposit3period"]),
                "timedeposit3interest"   => str_replace(",",".", $_POST["bafv_timedeposit3interest"]),
                "timedeposit4name"       => $_POST["bafv_timedeposit4name"],
                "timedeposit4period"     => str_replace(",",".", $_POST["bafv_timedeposit4period"]),
                "timedeposit4interest"   => str_replace(",",".", $_POST["bafv_timedeposit4interest"]),
                "bankmanagerid"          => $_POST["bafv_bankmanagerid"]);
        $result = $li->bank_update_params($_SESSION['us_secId'],$lang,$bankparams);

        // error handling
        if(isFault($result))
        {
            $message = $result[0]["faultString"];
            display_bankparam_update_form($message,$bankparams);
        }
        // display updated parameters
        else
        { 
            $message = getMessage("2054");
            $result = $li->bank_read_params($_SESSION['us_secId'],$lang,$bankparams['bankid']);                                                                  
            $bankparams=$result[0];

            display_bankparam_update_form($message, $bankparams);
            exit;
        }
    }
}
function getEmptyBankparams() {
    $bankparams = array(
            "bankname"               => "",
            "bankid"                 => "",
            "bankaccountid"          => "",
            "accountstartfee"        => "",
            "accountendfee"          => "",
            "girocharge"             => "",
            "remittancefee"          => "",
            "standingorderfirstfee"  => "",
            "standingorderendfee"    => "",
            "bankwithdrawalstartfee" => "",
            "bankwithdrawalendfee"   => "",
            "bankbookinterest"       => "",
            "creditfee"              => "",
            "creditinterest"         => "",
            "overdraftinterest"      => "",
            "bankmanagerid"          => "",
            "timedeposit1name"       => "",
            "timedeposit1period"     => "",
            "timedeposit1interest"   => "",
            "timedeposit2name"       => "",
            "timedeposit2period"     => "",
            "timedeposit2interest"   => "",
            "timedeposit3name"       => "",
            "timedeposit3period"     => "",
            "timedeposit3interest"   => "",
            "timedeposit4name"       => "",
            "timedeposit4period"     => "",
            "timedeposit4interest"   => ""
      );
      return $bankparams;
}
?>