<?php
/**
 * MiNBank user interface: list of banks
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_banklist.php,v $
 * $Author: eltres $
 * $Date: 2007/01/21 02:47:16 $
 * $Revision: 1.9 $
 */

session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface for a business object
require_once("$minsoft_path/minba/$cf_local_interface/bali_centralbank.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_bank.php");
require_once("$baui_form_path/bafo_banklist.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utxr_client.php");

session_start();

if(isset($_POST["bafv_submit_bkback"]))
{
    require_once("baui_banksystem.php");
    exit;
}

if(isset($_POST["bafv_submit_cbkadmin"]))
{
    require_once("baui_centralbank.php");
    exit;
}

elseif(isset($_GET["soexecute"]))
{
    // execute standing orders
    require_once("$minsoft_path/minba/$cf_local_interface/bali_standingorder.php");
    $standingorderLi = &new StandingorderLi;
    $result = $standingorderLi->execute($_SESSION['us_secId'], $cf_lang);
    if(isFault($result))
        $bafv_msg = $result[0]['faultString'];
    else
    {        
        $bafv_msg = getMessage("2075")." ".$result;
    }
    process_banklist();
    exit;    
}    

if(isset($_GET["tax"]))
{
    require_once("$minsoft_path/minba/$cf_local_interface/bali_tax.php");
    $taxLi = &new TaxLi;
    $result = $taxLi->execute($_SESSION['us_secId'], $cf_lang);
    
    $result1 = $taxLi->gettax($_SESSION['us_secId'], $cf_lang);
    if(isFault($result))
        $bafv_msg = $result[0]['faultString'];
    else
    {        
      $bafv_msg = "";//getMessage("2075")." ".$result;
    }

        if(isFault($result1))
        $bafv_msg = $bafv_msg.$result1[0]['faultString'];
    else
    {        
        $bafv_msg = $bafv_msg.getMessage("2075")." ".$result;
    }
    
    process_banklist();
    exit;    
}    



if(isset($_POST["bafv_submit_bkneu"]) || isset($_POST["bafv_submit_create"])) 
{
           $_SESSION['act_role'] = utrl_centralbankmanager;
           process_bank_create();
           exit;
}
if(isset($_POST["bafv_submit_update"])) 
{
           $_SESSION['act_role'] = utrl_centralbankmanager;
           $bankid = "dummy";
           process_bank_update($bankid);
           exit;
}
if(isset($_POST["bafv_submit_bkad"]))
{ 
    $bkad= $_POST["bafv_bkad"];
    $func = strtok($bkad,":");
    $bankid = strtok(";");
    switch ($func)
    {
        case 1:
            process_bank_update($bankid);
            exit;
            break;
        case 2:
            process_bank_delete($bankid);
            process_banklist();
            exit;
            break;
        default:
              $bafv_msg =getMessage("2007");
              exit;
              break;
    }
}
else
{
  process_banklist();
}

/**
 * Shows a list of all banks. The centralbankmanager is allowed to create,
 * update,delete a bank or display its values
 */
function process_banklist()
{  
    global $cf_lang;
    global $bafv_msg;
    global $bafv_errno;
    
    global $banklist;
    global $baui_customer_list;
    
    $bafv_errno = "";
    
    // lokales Interface initialisieren
    $li = &new CentralbankLi;
    $lang = $cf_lang;
    
    $secResult = checkSecurity($_SESSION['us_secId']);
    if(isFault($secResult))
      {
	return $secResult;
      }
    else
      {
	$us_id = $secResult["userid"];
	$us_role = $secResult["role"];    
      }

     // check if user is bankmanager    
    if(!($us_role & utrl_centralbankmanager))
    {
        // hier Fehler ausgeben!
        $bafv_msg = getMessage("2032");
        $baui_banklist = NULL;
        $bafv_errno = "2032";
        display_banklist_form();    
        exit;
    }
    
    //get list of banks
    $result = $li->getbanklist($_SESSION['us_secId'],$lang);
    
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_banklist_form();
        exit;    
    }
    else
    {   
        foreach ($result as $number => $bank)
        {
            $banklist = $result;
            display_banklist_form();
            exit;
            
        }                
    }
}

/**
 * Creates a bank.
 */
function process_bank_create()
{  
    global $cf_lang;
    global $bafv_msg;
    
    global $bafv_bankname;
    global $bafv_bankid;
    global $bafv_bankmanagerid;
    
    $inputerror = FALSE; 
    
    // initialise local interface
    $li = &new BankLi;
    $lang = $cf_lang;
    
    if(!isset($_POST["bafv_submit_create"]))
    {
        display_bank_create_form();
        exit;
    }
    
    // user input is checked in the Bank business objekt    
    if($inputerror == FALSE)
    {
        $bank =  array( 
                "bankname" =>      $_POST["bafv_bankname"], 
                "bankid" =>        $_POST["bafv_bankid"],
                "bankmanagerid" => $_POST["bafv_bankmanagerid"]);
                                            
        $result = $li->bank_create($_SESSION['us_secId'],$lang,$bank);
                        
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_bank_create_form();    
        }
        // clear input fields
        else
        {
            $bafv_bankname = "";
            $bafv_bankid ="";
            $bafv_bankmanagerid = "";
            $bafv_msg = getMessage("2054");
            display_bank_create_form();
        }    
    }
}

/**
 * Updates a bank.
 *
 * @param bankid id of bank
 */
function process_bank_update($bankid)
{  
    global $cf_lang;
    global $bafv_msg;
    global $bafv_bankname;
    global $bafv_bankid;
    global $bafv_bankmanagerid;
    
    $inputerror = FALSE; 
    
    // initialise local interface
    $li = &new BankLi;
    $lang = $cf_lang;
    $bafv_bankid = $bankid;
    
    if(!isset($_POST["bafv_submit_update"]))
    {
        // get bank informations and display
        $result = $li->bank_read_params($_SESSION['us_secId'],$lang,$bankid);
        
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_bank_update_form(); 
            exit;   
        }
        else
        {
            $bafv_bankid = $result[0]["bankid"];
            $bafv_bankname = $result[0]["bankname"];
            $bafv_bankmanagerid = $result[0]["bankmanagerid"];
        
            display_bank_update_form();
            exit;
        }
    }
                                            
    // user input is checked in the Bank business objekt    
    if($inputerror == FALSE)
    {
        $bafv_bankid = $_POST["bafv_bankid"];
        $bafv_bankname = $_POST["bafv_bankname"];
        $bafv_bankmanagerid = $_POST["bafv_bankmanagerid"];
        
        $bank =  array( 
                "bankid" =>        $bafv_bankid,
                "bankname" =>      $bafv_bankname, 
                "bankmanagerid" => $bafv_bankmanagerid);
                                                
        $result = $li->bank_update($_SESSION['us_secId'],$lang,$bank);
                        
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_bank_update_form();    
        }
        else
        {
            // display success message
            $bafv_msg = getMessage("2054");
            display_bank_update_form();
        }
    }
}

/**
 * Removes a bank.
 * @param bankid id of bank to be removed
 */
function process_bank_delete($bankid)
{  
    global $cf_lang;
    global $bafv_msg;
    
    $inputerror = FALSE; 
    
    // initialise local interface
    $li = &new BankLi;
    $lang = $cf_lang;
    
    // user input is checked in the Bank business objekt    
    if($inputerror == FALSE)
    {                                
        $result = $li->bank_delete($_SESSION['us_secId'],$lang,$bankid);
                        
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            process_banklist();
            exit;    
        }
    }                
}
?>