<?php
/**
 * MiNBank user interface: bank system
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_banksystem.php,v $
 * $Author: mboller $
 * $Date: 2006/01/08 23:11:22 $
 * $Revision: 1.11 $
 */
 
session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface for a business object
require_once("$minsoft_path/minba/$cf_local_interface/bali_centralbank.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_customer.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_bank.php");
require_once("$baui_form_path/bafo_banksystem.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_checkit.php");

//c check submit and radio buttons
if(isset($_POST["bafv_submit_bback"]))
{
    require_once("$minsoft_path/ms_menu.php");
    display_ms_menu();
    exit;
}

//c check submit and radio buttons
if(isset($_POST["bafv_submit_become_customer"]))
{
  if ($_GET['action']=="create")
    {
      	process_user_kunde_input();
	exit;
    }
  else
    {
      require_once("form_de/bafo_customer.php");
      display_become_customer_form();
      exit;
    }
}

if(isset($_POST["bafv_submit_bankid"]))
{
   $ret = $_POST["bafv_bkf"];
   $baui_func = strtok($ret,":");
   $_SESSION['selected_customer']= strtok(":");
   $_SESSION['baui_bankid'] = strtok(":");
   $_SESSION['baui_bankname'] = strtok(":");

   if($baui_func == "wm")
   {
           $_SESSION['act_role'] = utrl_mineconomics;
           require_once("baui_economic.php");
           exit;
   }
   if($baui_func == "cbm")
   {
           $_SESSION['act_role'] = utrl_centralbankmanager;
           require_once("baui_banklist.php");
           exit;
   }
   if($baui_func != "Bankdirektor")
   {
           $_SESSION['act_role'] = utrl_customer;
           require_once("baui_accountlist.php");
           exit;
   }
   else
   {
           $_SESSION['act_role'] = utrl_bankmanager;
           $act_bankmanagerid = $_SESSION['us_id'];
           require_once("baui_customerlist.php");
           exit;
   }
}
else
{
    process_banksystem();
}

// read list of banks and display
function process_banksystem()
{
    global $xmlrpc_host;
    global $xmlrpc_path;
    global $cf_lang;
    global $bafv_msg;
    global $customerlist;
    global $is_centralbankmanager;
    global $is_mineconomics;
    global $is_customer;

    // initialise local interface
    $li = &new CentralbankLi;
    $lang = $cf_lang;
    $mineconomics = NULL;
    $centralbankmanager = NULL;

    // get all user roles
    $result = $li->check_roles($_SESSION['us_secId'],$lang);

    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
      echo "Zugang verweigert";

       // display_banksystem_form();
        exit;
    }
    else
    {
        // display available selections
        if(array_key_exists(utrl_mineconomics,$result))
        {
            $is_mineconomics = $_SESSION['us_id'];
        }
        if(array_key_exists(utrl_centralbankmanager,$result))
        {
            $is_centralbankmanager = $_SESSION['us_id'];
        }
        if(array_key_exists(utrl_customer,$result))
        {
            $is_customer = 1;
        }

    }

    $result = $li->getbanklist($_SESSION['us_secId'],$lang);
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_banksystem_form();
        exit;
    }
    else
    {
        foreach ($result as $number => $bank)
        {
            foreach ($bank as $n3 => $n4)
            {
               $_SESSION['baui_banklist'][$number][$n3] = $n4;
            }
        }

        // initialise local interface
        $li = &new CustomerLi;
        $lang = $cf_lang;

        $customerlist = NULL;
        $count = 0;
        $count_cust = 0;
        // is user a bank customer?
        // is deputee for other customers?
        foreach ($_SESSION['baui_banklist'] as $number => $bank)
        {
               $count1 = 0;
               $bankid = $_SESSION['baui_banklist'][$number]["bankid"];
               $bankname = $_SESSION['baui_banklist'][$number]["bankname"];
               $bankmanager = $_SESSION['baui_banklist'][$number]["bankmanagerid"];

               $result = $li->customer_deputee($_SESSION['us_secId'],$lang,$_SESSION['us_id'],$bankid);

               // error handling
                 if(isFault($result))
                {
                    $bafv_msg = $result[0]["faultString"];
                    display_banksystem_form();
                    exit;
                }
                else
                {
                    if($result != NULL)
                    {
                        $customerlist[$count]["bankid"] =$bankid;
                           $customerlist[$count]["bankname"] = $bankname;
                        if($bankmanager == $_SESSION['us_id'])
                        {
                            $customerlist[$count]["customer"][$count1] =
                                array("customername"=>"Bankdirektor",
                                  "customerid"=>$_SESSION['us_id']);
                            $count1++;
                            $count_cust++;
                        }

                        // insert customer and customer deputees
                        if(is_array($result))
                        {
                            foreach($result as $number => $array)
                            {
                                $customerlist[$count]["customer"][$count1] =
                                array("customername"=>$array["customername"],
                                "customerid"=>$array["customerid"]);
                                $count1++;
                                $count_cust++;
                            }
                        }
                    }
                    $count++;
                }
        }
        // no customer, no bankmanager authority beloning to a private bank
        if ($count_cust == NULL)
        {
            $customerlist = NULL;
        }
        display_banksystem_form();
        exit;
    }
}



// create a customer
function process_user_kunde_input()
{  
    global $cf_lang;
    global $bafv_msg;    
    global $bafv_name;
    global $bafv_email;
    global $bafv_custid;
    global $bafv_custart;
    global $bafv_stateid;
    global $bafv_country;
    global $bafv_town;
    global $bafv_street;
    global $customerart;
    global $countrylist;
    global $townlist;

    require_once("form_de/bafo_customer.php");
    require_once("../../utility/utgn_config.php");
    
    $inputerror = FALSE; 
  //   // initialise local interface
//     $li = &new CustomerLi;
//     $lang = $cf_lang;
    
//     // get list of kind of customers
//     $result = $li->get_customer_art($_SESSION['us_secId'],$lang);
    
//     // error handling
//     if(isFault($result))
//     {
//       echo "result$result[0][]";
//       $bafv_msg = $result[0]["faultString"];
//       display_become_customer_form();    
//     }
    
//     $customerart = $result;    
    
    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;
    
    // user input is checked in the Bank business objekt    
    if($inputerror == FALSE)
    {
        $cust =  array( 
		       "name" => $_POST["bafv_name"], 
		       "email" =>$_POST["bafv_email"],
		       "custid" =>$_POST["bafv_custid"],
		       "custart" =>$_POST["bafv_custart"],
		       "stateid" => $_POST["bafv_stateid"],
		       "country" => $_POST["bafv_country"],
		       "town" => $_POST["bafv_town"],
		       "street" => $_POST["bafv_street"],
		       "bankid" => $_POST['bafv_bankid']);
	
                                            
        $result = $li->create($_SESSION['us_secId'],$lang,$cust);
   
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_become_customer_form();    
        }
        // clear input fields
        else
        {

	  if (($_POST["bafv_custid"])!=($_SESSION['us_id'])){
	    // become deputee
	    require("../../utility/utgn_config.php");
	    $db = &new DBAccess();
	    $sid=$_SESSION['us_id'];
	    $sql = "insert into {$utcv_db_prefix}deputeecust VALUES ('".$sid."','".$_POST['bafv_bankid']."','".$_POST["bafv_custid"]."','9')";
	    	    $db->query($sql);
	    }


	  //TO DO
	  // mail Bankmanager

        }    
	
	echo "Kunde angelegt. Der Kunde muss nun vom Bankmanager best&auml;tigt werden";
        process_banksystem();


    }
    
}


?>
