<?php
/**
 * MiNBank user interface: cental bank
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_centralbank.php,v $
 * $Author: mboller $
 * $Date: 2006/01/05 00:53:07 $
 * $Revision: 1.4 $
 */

session_start();
   
require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface of a business objekt
require_once("$minsoft_path/minba/$cf_local_interface/bali_centralbank.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_account.php");
require_once("$baui_form_path/bafo_centralbank.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");
     
/************************  main **********************************/
// ceck submit and radio buttons
if(isset($_POST["bafv_submit_back"]))
{
    require_once("baui_banklist.php");
    process_banklist();
    exit;
}
elseif(isset($_POST["bafv_submit_central_update"]))
{
    process_centralbank_update_params();
    exit;
}
else
{
    process_centralbank_update_params();
    exit;
}
    
/**
 * Updates centralbank information.
 */
function process_centralbank_update_params()
{  
    global $cf_lang;
    global $bafv_msg;
    
    global $bafv_centralbankname;
    global $bafv_stateid;
    global $bafv_refinance;
    global $bafv_minreserve;
    global $bafv_reservebankid;
    global $bafv_reserveaccountid;
    global $bafv_refinancebankid;
    global $bafv_refinanceaccountid;
    global $bafv_centralbankid;
    global $bafv_centralaccountid;
    global $bafv_centralamount;
    global $bafv_centralamountdel;
    global $bafv_centralamountinc;
    
    $bafv_msg = ""; 
    
    // initialise local interface
    $li = &new CentralbankLi;
    $lang = $cf_lang;
    
    $li1 =&new AccountLi;
    if(!isset($_POST["bafv_submit_central_update"]))
    {
        $bafv_centralamountinc = "";
        $bafv_centralamountdel = "";
        
        $result = $li->centralbank_read_params($_SESSION['us_secId'],$lang);
        $centralbankparams =$result[0];                                     
        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_centralbank_update_form();
            exit;    
        }
        if(!is_array($result))
        {
            $bafv_msg = getFault("2011");
            $bafv_centralbankname = "";
            $bafv_stateid = "";
            $bafv_refinance = "";
            $bafv_minreserve = "";
            $bafv_reservebankid = "";
            $bafv_reserveaccountid = "";
            $bafv_refinancebankid = "";
            $bafv_refinanceaccountid = "";
            $bafv_centralbankid = "";
            $bafv_centralaccountid = "";    
            display_centralbank_update_form();
            exit;    
        }
        // show centralbank information if valid parameters
        else
        {   
            $bafv_centralbankname = $centralbankparams['centralbankname'];
            $bafv_stateid = $centralbankparams['stateid'];
            $bafv_refinance = $centralbankparams['refinance'];
            $bafv_refinance = str_replace(",",".",$bafv_refinance);
            $bafv_minreserve = $centralbankparams['minreserve'];
            $bafv_minreserve = str_replace(",",".",$bafv_minreserve);
            $bafv_reservebankid = $centralbankparams['reservebankid'];
            $bafv_reserveaccountid = $centralbankparams['reserveaccountid'];
            $bafv_refinancebankid = $centralbankparams['refinancebankid'];
            $bafv_refinanceaccountid = $centralbankparams['refinanceaccountid'];
            $bafv_centralbankid = $centralbankparams['centralbankid'];
            $bafv_centralaccountid = $centralbankparams['centralaccountid'];
            
            // get amount of centralaccount
            $result = $li1->read($_SESSION['us_secId'],$lang,$bafv_centralaccountid,$bafv_centralbankid);                                                                                                  
                                               
            // error handling
            if(isFault($result))
            {
                $bafv_msg = $result[0]["faultString"];
                display_centralbank_update_form();
                exit;    
            }
            
            // display account information
            else
            {
                $bafv_centralamount = $result['accountbalance'];
                $bafv_msg = "";
                display_centralbank_update_form();
                exit;
            }    
        }
           
    }
        
    // update parameters
    $centralbankparams =  array(
            "centralbankname" => $_POST["bafv_centralbankname"],
            "stateid" => $_POST["bafv_stateid"],
            "refinance" => str_replace(",",".",$_POST["bafv_refinance"]),
            "minreserve" => str_replace(",",".",$_POST["bafv_minreserve"]) ,
            "reservebankid" => $_POST["bafv_reservebankid"],
            "reserveaccountid" => $_POST["bafv_reserveaccountid"],
            "refinancebankid" => $_POST["bafv_refinancebankid"],
            "refinanceaccountid" => $_POST["bafv_refinanceaccountid"],
            "centralbankid" => $_POST["bafv_centralbankid"],
            "centralaccountid" => $_POST["bafv_centralaccountid"]);
                                
    $result = $li->centralbank_update_params($_SESSION['us_secId'],$lang,$centralbankparams);             
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_centralbank_update_form();    
    }
    // clear input fields
    else
    {
        // check money changes for centralaccountid
        $bafv_centralamountdel = str_replace(",",".",$_POST["bafv_centralamountdel"]);
        $bafv_centralamountinc = str_replace(",",".",$_POST["bafv_centralamountinc"]);
        if ($bafv_centralamountinc > 0.0)
        {
            process_account_create_money();
        }
        if ($bafv_centralamountdel > 0.0)
        {
            process_account_eliminate_money();
        }
        $bafv_msg = getMessage("2058");
        $bafv_centralamountinc = "";
        $bafv_centralamountdel = "";
    
        $result = $li->centralbank_read_params($_SESSION['us_secId'],$lang);
        $centralbankparams =$result[0];                                     
    
        // show centralbank information if valid parameters
        $bafv_centralbankname = $centralbankparams['centralbankname'];
        $bafv_stateid = $centralbankparams['stateid'];
        $bafv_refinance = $centralbankparams['refinance'];
        $bafv_refinance = str_replace(",",".",$bafv_refinance);
        $bafv_minreserve = $centralbankparams['minreserve'];
        $bafv_minreserve = str_replace(",",".",$bafv_minreserve);
        $bafv_reservebankid = $centralbankparams['reservebankid'];
        $bafv_reserveaccountid = $centralbankparams['reserveaccountid'];
        $bafv_refinancebankid = $centralbankparams['refinancebankid'];
        $bafv_refinanceaccountid = $centralbankparams['refinanceaccountid'];
        $bafv_centralbankid = $centralbankparams['centralbankid'];
        $bafv_centralaccountid = $centralbankparams['centralaccountid'];
      
        // get amount of centralaccount
        $result = $li1->read($_SESSION['us_secId'],$lang,$bafv_centralaccountid,$bafv_centralbankid);                                                                                                  
        $bafv_centralamount = $result['accountbalance'];
        display_centralbank_update_form();
        
        exit;            
    }
}

/**
 * Eliminates money from country economics.
 */
function process_account_eliminate_money()
{  
    global $cf_lang;
    global $bafv_msg;
    
    global $bafv_centralbankid;
    global $bafv_centralaccountid;
    global $bafv_centralamount;
    global $bafv_centralamountdel;
     
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    $accountparams =  array(
                "centralbankid" => $_POST["bafv_centralbankid"],
                "centralaccountid" => $_POST["bafv_centralaccountid"],
                "centralamount" => str_replace(",",".",$_POST["bafv_centralamount"]),
                "centralamountdel" => str_replace(",",".",$_POST["bafv_centralamountdel"]));        
                
    $result = $li->account_eliminate_money($_SESSION['us_secId'],$lang,$accountparams);             
    // error handling 
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_centralbank_update_form();
        exit;    
    }
}

/**
 * produce money for country economics
 */
function process_account_create_money()
{  
    global $cf_lang;
    global $bafv_msg;
    
    global $bafv_centralbankid;
    global $bafv_centralaccountid;
    global $bafv_centralamount;
    global $bafv_centralamountinc;
     
    // initialise local interface
    $li = &new AccountLi;
    $lang = $cf_lang;
    
    $accountparams =  array(
                "centralbankid" => $_POST["bafv_centralbankid"],
                "centralaccountid" => $_POST["bafv_centralaccountid"],
                "centralamount" => str_replace(",",".",$_POST["bafv_centralamount"]),
                 "centralamountinc" => str_replace(",",".",$_POST["bafv_centralamountinc"]));
                 
    $result = $li->account_create_money($_SESSION['us_secId'],$lang,$accountparams);             
    // error handling 
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_centralbank_update_form();
        exit;    
    }
}
?>