<?php
/**
 * MiNBank user interface: customer
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_customer.php,v $
 * $Author: mboller $
 * $Date: 2006/01/08 00:20:19 $
 * $Revision: 1.7 $
 */

session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface of a business objekt
require_once("$minsoft_path/minba/$cf_local_interface/bali_customer.php");
require_once("$baui_form_path/bafo_customer.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");

/************************  main **********************************/

// ceck submit and radio buttons
if(isset($_POST["bafv_submit_back"]))
{
    require_once("baui_customerlist.php");
    exit;
}
if(isset($_POST["bafv_submit_create"]))
{
    process_user_kunde_input();
    exit;
}
if(isset($_POST["bafv_submit_update"]))
{
    $customerid = $_POST["bafv_custid"];
    process_customer_update($customerid);
    exit;
}
if(isset($_POST["bafv_submit_bvkdel"]))
{
    if(isset($_POST["bafv_deputeeid"]))
    {
        $deputeeid = $_POST["bafv_deputeeid"];
        process_customer_deputee_delete($deputeeid);
        exit;
    }
    else
    {
        $bafv_msg = getMessage("2045");
        process_customer_deputee($_SESSION['selected_customer']);
        exit;
    }
}
if(isset($_POST["bafv_submit_bvknew"]))
{
    $deputeeid = $_POST["bafv_deputeeid_new"];
    if($deputeeid == "")
    {
        $bafv_msg = getMessage("2046");
        process_customer_deputee($_SESSION['selected_customer']);
        exit;
    }
    else
    {
        process_customer_deputee_new($deputeeid);
        exit;
    }
}

/**
 * Creates a customer.
 *
 * @global $_SESSION['us_secId']
 */
function process_user_kunde_input()
{
    global $cf_lang;
    global $bafv_msg;

    global $bafv_name;
    global $bafv_email;
    global $bafv_custid;
    global $bafv_custart;
    global $bafv_stateid;
    global $bafv_country;
    global $bafv_town;
    global $bafv_street;
    global $customerart;


    $inputerror = FALSE;
    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;

    // get list of kind of customers
    $result = $li->get_customer_art($_SESSION['us_secId'],$lang);

    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_customer_create_form();
    }

    $customerart = $result;
    if(!isset($_POST["bafv_submit_create"]))
    {

        display_customer_create_form();
        exit;
    }

    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;

    // user input is checked in the Bank business objekt
    if($inputerror == FALSE)
    {
        $cust =  array(
                "name" => $_POST["bafv_name"],
                "email" =>$_POST["bafv_email"],
                "custid" =>$_POST["bafv_custid"],
                "custart" =>$_POST["bafv_custart"],
                "stateid" => $_POST["bafv_stateid"],
                "country" => $_POST["bafv_country"],
                "town" => $_POST["bafv_town"],
                "street" => $_POST["bafv_street"],
                "bankid" => $_SESSION['baui_bankid']);


        $result = $li->create($_SESSION['us_secId'],$lang,$cust);

        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_customer_create_form();
        }
        // clear input fields
        else
        {
            $bafv_name = "";
            $bafv_email ="";
            $bafv_custid = "";
            $bafv_custart= "";
            $bafv_stateid = "";
            $bafv_country = "";
            $bafv_town = "";
            $bafv_street = "";
            $bafv_msg = getMessage("2038");
            display_customer_create_form();
        }

    }

}

/**
 * Reads customer information.
 *
 * @param customer id of customer
 * @global $_SESSION['us_secId'] security id
 * @global $_SESSION['baui_bankid'] bank id
 */
function process_customer_read($customerid)
{
    global $cf_lang;
    global $bafv_msg;

    global $bafv_name;
    global $bafv_email;
    global $bafv_custid;
    global $bafv_custart;
    global $bafv_stateid;
    global $bafv_country;
    global $bafv_town;
    global $bafv_street;
    global $bafv_custart_text;


    $inputerror = FALSE;

    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;
    $cust_art_list = NULL;

    // user input is check in the business objekt
    if($inputerror == FALSE)
    {
        $result = $li->get_customer_art($_SESSION['us_secId'],$lang);

        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_customer_read_form();
            exit;
        }
        else
        {
            $cust_art_list = $result;
        }

        $result = $li->read($_SESSION['us_secId'],$lang, $customerid,$_SESSION['baui_bankid']);

        // error handling
        if(isFault($result))
        {
            display_customer_read_form();
            exit;
        }
        if(!is_array($result))
        {
            $bafv_msg = getFault("2011");
            $bafv_name = "";
            $bafv_email ="";
            $bafv_custid = "";
            $bafv_custart= "";
            $bafv_stateid = "";
            $bafv_country = "";
            $bafv_town = "";
            $bafv_street = "";
            $bafv_custart_text = "";
            display_customer_read_form();
            exit;
        }
        // show customer information
        else
        {
            $bafv_name = $result['name'];
            $bafv_email =$result['email'];
            $bafv_custid = $result['custid'];
            $bafv_custart= $result['custart'];
            $bafv_stateid = $result['stateid'];
            $bafv_country = $result['country'];
            $bafv_town = $result['town'];
            $bafv_street = $result['street'];
            $bafv_custart_text = $cust_art_list["$bafv_custart"];
            $bafv_msg = "";
            display_customer_read_form();
        }

    }

}

/**
 * Updates customer information.
 *
 * @param customer id of customer
 * @global $_SESSION['us_secId'] security id
 * @global $_SESSION['baui_bankid'] bank id
 */
function process_customer_update($customerid)
{
    global $cf_lang;
    global $bafv_msg;

    global $bafv_name;
    global $bafv_email;
    global $bafv_custid;
    global $bafv_custart;
    global $bafv_stateid;
    global $bafv_country;
    global $bafv_town;
    global $bafv_street;
    global $customerart;

    $inputerror = FALSE;

    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;


    // get list of kind of customers
    $result = $li->get_customer_art($_SESSION['us_secId'],$lang);

    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        display_customer_create_form();
    }
    $customerart = $result;

    if(!isset($_POST["bafv_submit_update"]))
    {

        $result = $li->read($_SESSION['us_secId'],$lang,$customerid,$_SESSION['baui_bankid']);

        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_customer_update_form();
            exit;
        }
        if(!is_array($result))
        {
            $bafv_msg = getFault("2011");
            display_customer_update_form();
            exit;
        }
        // show customer information if valid customer
        else
        {

            $bafv_name = $result['name'];
            $bafv_email =$result['email'];
            $bafv_custid = $result['custid'];
            $bafv_custart= $result['custart'];
            $bafv_stateid = $result['stateid'];
            $bafv_country = $result['country'];
            $bafv_town = $result['town'];
            $bafv_street = $result['street'];
            $bafv_msg = "";
            display_customer_update_form();
        }
        exit;
    }

    if($inputerror == FALSE)
    {

        $cust =  array(
                    "name" => $_POST["bafv_name"],
                    "email" =>$_POST["bafv_email"],
                    "custid" =>$_POST["bafv_custid"],
                    "custart"=> $_POST["bafv_custart"],
                    "stateid" =>$_POST["bafv_stateid"],
                    "country" => $_POST["bafv_country"],
                    "town" => $_POST["bafv_town"],
                    "street" => $_POST["bafv_street"],
                    "bankid" => $_SESSION['baui_bankid']);

        $result = $li->update($_SESSION['us_secId'],$lang,$cust);

        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_customer_update_form();
            exit;
        }
        // show customer information if update successful
        else
        {
            $bafv_msg = getMessage("2039");
            display_customer_update_form();
        }
    }
}



/**
 * Deletes a customer.
 *
 * @param customer id of customer
 * @global $_SESSION['us_secId'] security id
 * @global $_SESSION['baui_bankid'] bank id
 */
function process_customer_delete($customerid)
{
    global $cf_lang;
    global $bafv_msg;

    global $bafv_custid;

    // initialise a local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;

    $result = $li->delete($_SESSION['us_secId'],$lang,$customerid,$_SESSION['baui_bankid']);

    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
    }
}

/**
 * Displays a list of deputees of a customer.
 *
 * @param customer id of customer
 * @global $_SESSION['us_secId'] security id
 * @global $_SESSION['baui_bankid'] bank id
 */
function process_customer_deputee($customerid)
{
    global $cf_lang;
    global $bafv_msg;

    $inputerror = FALSE;
    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;

    // user input is checked in the business object Customer
    if($inputerror == FALSE)
    {
        $result = $li->deputee_customer($_SESSION['us_secId'],$lang,$customerid,$_SESSION['baui_bankid']);

        // error handling
        if(isFault($result))
        {
            $bafv_msg = $result[0]["faultString"];
            display_customer_deputee_form(null);
            exit;
        }
        // display if successfull
        else
        {
            display_customer_deputee_form($result);
        }
    }
}

/**
 * Deletes a deputee of a customer
 *
 * @param customer id of customer
 * @global $_SESSION['us_secId'] security id
 * @global $_SESSION['selected_customer'] selected customer
 */
function process_customer_deputee_delete($deputeeid)
{
    global $cf_lang;
    global $bafv_msg;

    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;
    $result = $li->customer_deputee_delete($_SESSION['us_secId'],
            $lang,$_SESSION['selected_customer'],
            $_SESSION['baui_bankid'],$deputeeid);

    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        process_customer_deputee($_SESSION['selected_customer']);
    }
    else
    {
        $bafv_customer = "";
        $bafv_deputeeid_new = "";
        $bafv_msg = "";
        process_customer_deputee($_SESSION['selected_customer']);
    }
}

/**
 * Inserts a new deputee member for a cutomer.
 *
 * @param customer id of customer
 * @global $_SESSION['us_secId'] security id
 * @global $_SESSION['baui_bankid'] bank id
 * @global $_SESSION['selected_customer'] selected customer
 */
function process_customer_deputee_new($deputeeid)
{
    global $cf_lang;
    global $bafv_msg;
    global $bafv_deputeeid_new;

    // initialise local interface
    $li = &new CustomerLi;
    $lang = $cf_lang;

    $result = $li->customer_deputee_new($_SESSION['us_secId'],$lang,
                $_SESSION['selected_customer'],
                $_SESSION['baui_bankid'],$deputeeid);
    // error handling
    if(isFault($result))
    {
        $bafv_msg = $result[0]["faultString"];
        process_customer_deputee($_SESSION['selected_customer']);
    }
    else
    {
        $bafv_customer = "";
        $bafv_deputeeid_new = "";
        $bafv_msg = "";
        process_customer_deputee($_SESSION['selected_customer']);
    }
}
?>