<?php
/**
 * MiNBank user interface: standing order
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/baui_standingorder.php,v $
 * $Author: mboller $
 * $Date: 2006/01/03 15:01:46 $
 * $Revision: 1.5 $
 */

session_start();

require_once("../bagn_config.php");
require_once("$minsoft_path/user/ui_std/usui_utility.php");
check_timeout();

// local interface of a business objekt
require_once("$minsoft_path/minba/$cf_local_interface/bali_standingorder.php");
require_once("$minsoft_path/minba/$cf_local_interface/bali_account.php");
require_once("$baui_form_path/bafo_standingorder.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_trace.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");


/************************  main **********************************/

// ceck submit and radio buttons
if(isset($_POST["bafv_submit_back"]))
{
    if(isset($_GET['action']) && $_GET['action'] == 'list')
        require("baui_accountlist.php");
    else
        process_standingorders("", $_SESSION["selected_accountid"]);
}
elseif(isset($_POST["bafv_submit_new"]))
{
    process_standingorder_create();
}
elseif(isset($_POST["bafv_submit_create"]))
{
    process_standingorder_create();
}
elseif(isset($_POST["bafv_submit_update"]))
{
    process_standingorder_update($_POST['bafv_soid']);
}
elseif(isset($_GET['action']) && $_GET['action'] == 'selshow')
{
    process_standingorder_display($_GET['id']);
}
elseif(isset($_GET['action']) && $_GET['action'] == 'selchange')
{
    process_standingorder_update($_GET['id']);
}
elseif(isset($_GET['action']) && $_GET['action'] == 'seldelete')
{
    process_standingorder_delete($_GET['id']);
}

/**
 * Displays standing order information belonging to an account.
 *
 * @param accountid id of account
 */
function process_standingorders($message, $accountid)
{
    global $cf_lang;
    global $bafv_msg;

    // get account local interface
    $li = &new AccountLi;
    $lang = $cf_lang;

    // get the standing orders
    $account_standingorder_list = null;
    $bafv_msg = "";
    $result = $li->standingorder_list($_SESSION['us_secId'], $lang, $accountid, $_SESSION['baui_bankid']);
    if(isFault($result)) {
        $account_standingorder_list = null;
        $bafv_msg = $result[0]["faultString"];
    }
    else {
        if(is_array($result)) {
            $account_standingorder_list = $result;
        }
        else {
            $account_standingorder_list = null;
        }
    }
    
    // display standing order list form
    if($message != "")
        $bafv_msg = $message;
    display_standingorder_list_form($bafv_msg, $account_standingorder_list);
}

/**
 * Creates a standing order.
 */
function process_standingorder_create()
{
    global $cf_lang;

    // show initial empty form
    if(! isset($_POST['bafv_submit_create'])) {
        $standingorder =  get_empty_standingorder();
        $standingorder['nextexecution'] = time();
        $message = "";
        display_standingorder_create_form($message, $standingorder);
        exit;
    }
    $inputerror = FALSE;

    // initialise local interface
    $li = &new StandingorderLi;
    $lang = $cf_lang;

    // user input is checked in the Bank business objekt
    if($inputerror == FALSE)
    {
        switch($_POST["bafv_period"]) {
            case 0:
                $time = "0";
                break;
            case 1:
                $time = $_POST["bafv_weekly"];
                break;
            case 2:
                $time = $_POST["bafv_monthly"];
                break;
        }
        
        // convert next execution date from string to timestamp
        $day = strtok($_POST["bafv_nextexecution"], ".");
        $month = strtok(".");
        $year = strtok("");
        $nextexecution = mktime(0, 0, 0, $month, $day, $year);
        $standingorder =  array(
                "remitteraccountid" => $_SESSION['selected_accountid'],
                "remitterbankid" => $_SESSION['baui_bankid'],
                "payeeaccountid" => $_POST['bafv_toaccountid'],
                "payeebankid" => $_POST['bafv_tobankid'],
                "customerid" => $_SESSION['selected_customer'],
                "purpose" => $_POST["bafv_purpose"],
                "currencyid" => $_POST["bafv_currencyid"],
                "amount" => $_POST["bafv_amount"],
                "payeename" => $_POST["bafv_payeename"],
                "period" => $_POST["bafv_period"],
                "nextexecution" => $nextexecution,
                "time" => $time,
                "lastexecuted" => "0");

        $result = $li->create($_SESSION['us_secId'],$lang,$standingorder);

        // error handling
        if(isFault($result))
        {
            // show error message
            $message = $result[0]["faultString"];
            display_standingorder_create_form($message, $standingorder);
            exit;
        }
        else
        {
            // show ok message
            $standingorder =  get_empty_standingorder();
            $message = getMessage("2072");
            display_standingorder_create_form($message, $standingorder);
        }
    }
}

/**
 * Reads standingorder information.
 *
 * @param soid id of standing order
 */
function process_standingorder_display($soid)
{
    global $cf_lang;

    $inputerror = FALSE;

    // initialise local interface
    $li = &new StandingorderLi;
    $lang = $cf_lang;

    // initialize attributes
    $standingorder =  get_empty_standingorder();

    $result = $li->read($_SESSION['us_secId'],$lang, $soid);

   // error handling
    if(isFault($result))
        $message = $result[0]["faultString"];
    else
        $standingorder = $result;
        
    display_standingorder_display_form($message, $standingorder);
}

/**
 * Updates customer information.
 *
 * @param soid id of standing order
 */
function process_standingorder_update($soid)
{
    global $cf_lang;

    $inputerror = FALSE;

    if(isset($_POST["bafv_submit_update"]))
    {
        // evaluate period
        switch($_POST["bafv_period"]) {
            case 0:
                $time = 0;
                break;
            case 1:
                $time = $_POST["bafv_weekly"];
                break;
            case 2:
                $time = $_POST["bafv_monthly"];
                break;
        }
        
        // convert string to timestamp
        $day = strtok($_POST["bafv_nextexecution"], ".");
        $month = strtok(".");
        $year = strtok("");
        $nextexecution = mktime(0, 0, 0, $month, $day, $year);

        // get data from form
        $standingorder =  array(
                "soid" => $soid,
                "remitteraccountid" => $_SESSION['selected_accountid'],
                "remitterbankid" => $_SESSION['baui_bankid'],
                "payeeaccountid" => $_POST['bafv_toaccountid'],
                "payeebankid" => $_POST['bafv_tobankid'],
                "customerid" => $_SESSION['selected_customer'],
                "purpose" => $_POST["bafv_purpose"],
                "currencyid" => $_POST["bafv_currencyid"],
                "amount" => $_POST["bafv_amount"],
                "payeename" => $_POST["bafv_payeename"],
                "period" => $_POST["bafv_period"],
                "time" => $time,
                "nextexecution" => $nextexecution,
                "lastexecuted" => $_POST["bafv_lastexecuted"] );

        // update data in database
        $li = &new StandingorderLi;
        $result = $li->update($_SESSION['us_secId'], $lang, $standingorder);

        // error handling
        if(isFault($result))
        {
            $message = $result[0]["faultString"];
            display_standingorder_update_form($message, $standingorder);
        }
        // show customer information if update successful
        else
        {
            $message = getMessage("2073");
            display_standingorder_update_form($message, $standingorder);
        }
    }
    else {
        // read data from database
        $li = &new StandingorderLi;
        $result = $li->read($_SESSION['us_secId'], $lang, $soid, $_SESSION['baui_bankid']);

        if(isFault($result))
        {
            $message = $result[0]["faultString"];
            $standingorder = get_empty_standingorder();
            display_standingorder_update_form($message, $standingorder);
            exit;
        }

        if(!is_array($result))
        {
            $message= getFault("2011");
            $standingorder = get_empty_standingorder();
            display_standingorder_update_form($message, $standingorder);
            exit;
        }
        else
        {
            // show standing order
            display_standingorder_update_form($message, $result);
        }
        exit;
    }
}

/**
 * Deletes a standing order.
 *
 * @param soid id of standing order
 */
function process_standingorder_delete($soid)
{
    global $cf_lang;
    global $bafv_msg;

    // initialise a local interface
    $li = &new StandingorderLi;
    $lang = $cf_lang;

    // delete standing order in bankid
    $result = $li->delete($_SESSION['us_secId'],$lang,$soid);
    
    // error handling
    $message = "";
    if(isFault($result))
    {
        $message = $result[0]["faultString"];
    }
    
    process_standingorders($message, $_SESSION["selected_accountid"]);
}

function get_empty_standingorder() {
    return array(
            "remitteraccountid" => "",
            "remitterbankid" => "",
            "payeeaccountid" => "",
            "payeebankid" => "",
            "customerid" => "",
            "purpose" => "",
            "currencyid" => "",
            "amount" => "",
            "payeename" => "",
            "period" => "",
            "nextexecution" => time(),
            "time" => "");    
}
?>