<?php
/**
 * MiNBank form: account
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/form_de/bafo_account.php,v $
 * $Author: eltres $
 * $Date: 2007/01/21 01:21:14 $
 * $Revision: 1.11 $
 */

/**
 * Displays the form for creation of an account.
 *
 * @param $message message to be displayed
 * @param $account account attribute array
 */
function display_account_create_form($message, $account)
{
    global $minsoft_url;
    global $minsoft_path;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    echo <<<END
<h1>Konto Anlegen</h1>
<form action="baui_account.php?action=create" method="post">

<input type="hidden" name="bafv_accountid" value="{$account[accountid]}" />
<input type="hidden" name="bafv_kindofaccount" value="{$account[kindofaccount]}" />
<input type="hidden" name="bafv_accountcurrency" value="{$account[accountcurrency]}" />
<input type="hidden" name="bafv_accountowner" value="{$account[accountowner]}" />
<input type="hidden" name="bafv_bankid" value="{$account[bankid]}" />

<table>
<tr><td>Kontoart:</td><td>Girokonto</td></tr>
<tr><td>Kontoinhaber:</td><td>{$account[accountowner]}</td></tr>
<tr><td>Kontobezeichnung:</td>
    <td><input type="text" class="textfield" name="bafv_accountname"
     size="50" maxlength="50" value="{$account[accountname]}" /></td></tr>
<tr><td>W&auml;hrung:</td><td>{$account[accountcurrency]}</td></tr>
</table>
<br />
<input type="submit" name="bafv_submit_create" class="functionbutton" value="Anlegen" />
<input type="submit" name="bafv_submit_back" class="backbutton" value="Zur&uuml;ck" />
<input type="button" class="helpbutton" value="Hilfe"
    onclick="javascript:displayHelp('form_de/bahl_account_create.php');" />

</form>
<div class="message">{$message}</div>
END;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Display the values of an account
 *
 * @param $message message to be displayed
 * @param $account account attribute array
 */
function display_account_read_form($message, $account)
{
    global $minsoft_url;
    global $minsoft_path;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

echo <<<END

<h1>Konto anzeigen</h1>
<form action="baui_account.php?action=read" method="post">
<input type="hidden" size="10" readonly name="bafv_accountid"
    value="{$account['accountid']}" />
<table>
<tr><td>Kontonummer:</td><td>{$account['accountid']}</td></tr>
<tr><td>Kontoart:</td><td>Girokonto</td></tr>
<tr><td>Kontoinhaber:</td><td>{$account['accountowner']}</td></tr>
<tr><td>Kontobezeichnung:</td><td>{$account['accountname']}</td></tr>
<tr><td>W&auml;hrung:</td><td>{$account['accountcurrency']}</td></tr>
<tr><td>Kontostand:</td><td>{$account['accountbalance']}</td></tr>
</table>
<br />
<input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck">
<input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe"
    onclick="javascript:displayHelp('form_de/bahl_account_read.php');" />
</form>
<div class="message">$message</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Displays a form to change the values of an account.
 *
 * @param $message message to be displayed
 * @param $account account attribute array
 */
function display_account_update_form($message, $account)
{
    global $minsoft_url;
    global $minsoft_path;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

echo <<<END

<h1>Konto ndern</h1>
<form action="baui_account.php?action=update" method="post">
<input type="hidden" name="bafv_accountid" value="{$account['accountid']}" />
<input type="hidden" name="bafv_kindofaccount" value="{$account['kindofaccount']}" />
<input type="hidden" name="bafv_accountcurrency" value="{$account['accountcurrency']}" />
<input type="hidden" name="bafv_accountowner" value="{$account['accountowner']}" />
<input type="hidden" name="bafv_bankid" value="{$account['bankid']}" />
<table>
<tr><td>Kontonummer:</td><td>{$account['accountid']}</td></tr>
<tr><td>Kontoart:</td><td>Girokonto</td></tr>
<tr><td>Kontoinhaber:</td><td>{$account['accountowner']}</td></tr>
<tr><td>Kontobezeichnung:</td><td><input type="text" class="textfield" size="50" maxlength="50" name="bafv_accountname" class="textfield" value="{$account['accountname']}" /></td></tr>
<tr><td>W&auml;hrung:</td><td>{$account['accountcurrency']}</td></tr>
</table>
<br />
<input type="submit" name="bafv_submit_update" class="functionbutton" value="ndern" />
<input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck">
<input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe"
    onclick="javascript:displayHelp('form_de/bahl_account_read.php');" />
</form>
<div class="message">$message</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Displays a list of accounts.
 */
function display_account_list_form1()
{
    global $bafv_accountid;
    global $bafv_kindofaccount;
    global $bafv_accountcurrency;
    global $bafv_accountowner;
    global $bafv_msg;
    global $bafv_bankid;
    global $minsoft_url;
    global $minsoft_path;
    global $accountlist;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    echo <<<END
    <h1>Konten auflisten</h1>
    <form action="baui_customer.php?action=list method="post">
    <table>
    <tr><td>Konto-Id</td>
    <td>Kunden-Id  </td>
    <td>Bankleitzahl  </td>
    <tr>
END;
    if(is($accountlist))
    {
        foreach( $accountlist as $accountitem => $name)
        {
            foreach ($name as $key => $item)
            {
                echo <<<END
                <td>$item</td>
END;
            }
            echo <<<END
    </tr>
END;
        }
    }

    echo <<<END
    <input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck">
    <input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe"
        onclick="javascript:displayHelp('form_de/bahl_account_list.php');" />
    </form>
    <div class="message">$bafv_msg</div>
    </body>
    </head>
    </html>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Displays an account extract.
 */
function display_account_extract_form()
{

    global $bafv_msg;
    global $bafv_bankid;
    global $account_extract_list;
    global $minsoft_url;
    global $bafv_accountid;
    global $minsoft_path;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    echo <<<END
    <h1>Kontoauszug</h1>
    <form action="baui_account.php?action=extract" method="post">
END;
    if(is_array($account_extract_list))
    {
        echo <<<END
        <table>
        <tr><th>Datum</th>
        <th> Verwendungszweck</th>
        <th>W&auml;hrung</th>
        <th>Zu Lasten</th>
        <th>Zu Gunsten</th></tr>
END;
    }
    if(is_array($account_extract_list))
    {
        foreach( $account_extract_list as $accountitem => $name)
        {
            print("<tr>");
            foreach ($name as $key => $item)
            {
                if($item == '0')
                {
                    $item = "&nbsp;";
                }
                if($key == "debitamount" || $key ==    "favoramount")
                {
                    print("<td align=\"right\">$item</td>");
                }
                else
                {
                    print("<td>$item</td>");
                }

            }
                echo <<< END
                </tr>
END;
        }
    }

    echo <<<END
    </table>
    <br />
    <input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck">
    <input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe"
        onclick="javascript:displayHelp('form_de/bahl_account_extract.php');" />
    </form>
    <div class="message">$bafv_msg</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Displays a list of account deputees.
 */
function display_account_authority_form()
{
    global $bafv_msg;
    global $bafv_bankid;
    global $bafv_accountid;
    global $bafv_deputeeid;
    global $bafv_deputeeid_new;
    global $account_authority_list;
    global $minsoft_url;
    global $bafv_errno;
    global $minsoft_path;
    global $minsoft_path;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    echo <<<END
    <h1>Liste der Bevollm&auml;chtigten</h1>
    <form action="baui_account.php?action=authority" method="post">
    <table class="datatable">
END;
    $bafv_deputeeid = "";
    if(is_array($account_authority_list))
    {
        echo <<<END
        <tr><th>Konto-Id</th>
        <th>Bankleitzahl</th>
        <th>Bev.-Id</th>
        <th>Bev.-Name</th></tr>
END;
    }
    $count = 0;
    if(is_array($account_authority_list))
    {
        foreach( $account_authority_list as $accountitem => $name)
        {
            print("<tr>\n");
            foreach ($name as $key => $item)
            {
                print("<td>".$item."</td>\n");
            }

            $bafv_deputeeid =$name['deputeeid'];
            if ($count == 0)
            {
                echo <<<END
                <td align="center">
                <a class="menuitem" href="baui_account.php?bafv_deputeeid={$name['deputeeid']}&submit=bafv_submit_bvdel&action=authority">l&ouml;schen</a>
                </td>
END;
                $count++;
            }
            else
            {
                echo <<<END
                <td align="center">
                <a class="menuitem" href="baui_account.php?bafv_deputeeid={$name['deputeeid']}&submit=bafv_submit_bvdel&action=authority">l&ouml;schen</a>
                </td>
END;
            }
            print("</tr>\n");
        }
    }

    echo <<<END
    </table>
    <br />
    <table>
    <tr><td>Bev.-Id: </td>
    <td><input type="text" class="textfield" size="10" name="bafv_deputeeid_new"
    value ="$bafv_deputeeid_new" /></td>
    </tr>
    </table>
END;

    echo <<<END
    <input type="submit" class="functionbutton" name="bafv_submit_bvnew" value="neuer Bev." />
    <input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck" />
    <input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe"
        onclick="javascript:displayHelp('form_de/bahl_account_authority.php');" />
    </form>
    <div class="message">$bafv_msg</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}
?>