<?php
/**
 * MiNBank form: standing order
 *
 * $Source: /cvsroot/minbank/minba/minba/ui_std/form_de/bafo_standingorder.php,v $
 * $Author: mboller $
 * $Date: 2006/01/22 10:50:33 $
 * $Revision: 1.7 $
 */

/**
 * period names
 */
global $bafoso_periods;
$bafoso_periods = array("t&auml;glich", "w&ouml;chentlich", "monatlich");

/**
 * weekday names for time of week
 */
global $bafoso_weekdays;
$bafoso_weekdays = array("Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag","Sonntag");

/**
 * Displays a list of standing orders.
 *
 * @param message error message
 * @param standingorder standing order attributes
 */
function display_standingorder_list_form($message, $account_standingorder_list) {
    global $minsoft_path;
    global $minsoft_url;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    echo <<<END
<h1>Dauerauftr&auml;ge</h1>
<form action="baui_standingorder.php?action=list" method="post">
END;
    if($account_standingorder_list != null) {

    echo <<<END
<table class="menutable">
  <tr>
    <th>Empf&auml;ngername</th><th>Verwendungszweck</th><th>Betrag</th><th colspan="3">Funktionen</th>
  </tr>
END;

        foreach($account_standingorder_list as $standingorder) {
            $SID = SID;
echo <<<END
  <tr>
    <td>{$standingorder['payeename']}</td>
    <td>{$standingorder['purpose']}</td>
    <td>{$standingorder['amount']}</td>
    <td><a class="menuitem" href="{$minsoft_url}/minba/ui_std/baui_standingorder.php?action=selshow&amp;id={$standingorder[soid]}&amp;{$SID}">anzeigen</a></td>
    <td><a class="menuitem" href="{$minsoft_url}/minba/ui_std/baui_standingorder.php?action=selchange&amp;id={$standingorder[soid]}&amp;{$SID}">&auml;ndern</a></td>
    <td><a class="menuitem" href="{$minsoft_url}/minba/ui_std/baui_standingorder.php?action=seldelete&amp;id={$standingorder[soid]}&amp;{$SID}">l&ouml;schen</a></td>
  </tr>
END;
        }
    }
    if($account_standingorder_list != null) {
        print("</table>\n");
    }
    echo <<<END
<br />
<input type="submit" class="functionbutton" name="bafv_submit_new" value="Neu" />
<input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck" />
<input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe"
    onclick="javascript:displayHelp('form_de/bahl_customer_create.php');" />
</form>
<br />
<div class="message">$message</div>
END;

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");

}

/**
 * Diplays a form for creation of a new customer.
 *
 * @param message error message
 * @param standingorder standing order attributes
 */
function display_standingorder_create_form($message, $standingorder)
{
    global $minsoft_path;

    if($bafv_period === false)
        $bafv_period = 2;

    if($bafv_time === false)
        $bafv_rime = 1;

    // set link in main menu for accountlist
    global $mainmenu_extra1;
    $mainmenu_extra1 =
        "<a class=\"mainmenu\" target=\"_blank\" "
            ."href=\"{$minsoft_url}/external/accountlist.php\">Kontenliste</a>";

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    $timeArray = getdate($standingorder['nextexecution']);
    $nextexecution = $timeArray['mday'].".".$timeArray['mon'].".".$timeArray['year'];

    echo <<<END
<h1>Dauerauftrag anlegen</h1>
<form action="baui_standingorder.php?action=create" method="post">
<table>
<tr>
    <td><span class="mandatorylabel">Beg&uuml;nstigter:<br />Name, Vorname / Firma:</span></td>
    <td><input type="text" size="30" name="bafv_payeename" value="{$standingorder[payeename]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Konto-Nr. des Beg&uuml;nstigten:</span></td>
    <td><input type="text" size="8" name="bafv_toaccountid" value="{$standingorder[payeeaccountid]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Bankleitzahl:</span></td>
    <td><input type="text" size="10" name="bafv_tobankid" value="{$standingorder[payeebankid]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">W&auml;hrung:</span></td>
    <td><input type="text" size="10" name="bafv_currencyid" value="{$standingorder[currencyid]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Betrag:</span></td>
    <td><input type="text" size="10" name="bafv_amount" value="{$standingorder[amount]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Verwendungszweck:</span></td>
    <td><input type="text" size="50" name="bafv_purpose" value="{$standingorder[purpose]}" /></td></tr>
END;
    display_time_params($standingorder);
    echo <<<END
<tr><td><span class="mandatorylabel">Erste Ausf&uuml;hrung</span></td>
  <td><input class="menuitem" type="text" size="10" name="bafv_nextexecution" value="{$nextexecution}" /></td></tr>
</table>
<input type="submit" class="functionbutton" name="bafv_submit_create" value="OK" />
<input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck" />
<input type="button" class="helpbutton" name="bafv_submit_help" value="Hilfe" 
    onclick="javascript:displayHelp('form_de/bahl_customer_create.php');" />
</form>
<br />
<div class="message">$message</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Displays a form for update of standing order.
 *
 * @param message error message
 * @param standingorder standing order attributes
 */
function display_standingorder_update_form($message, $standingorder)
{
    global $minsoft_path;

    if($bafv_period === false)
        $bafv_period = 2;

    if($bafv_time === false)
        $bafv_rime = 1;

    // set link in main menu for accountlist
    global $mainmenu_extra1;
    $mainmenu_extra1 =
        "<a class=\"mainmenu\" target=\"_blank\" "
            ."href=\"{$minsoft_url}/external/accountlist.php\">Kontenliste</a>";

    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    $timeArray = getdate($standingorder['nextexecution']);
    $nextexecution = $timeArray['mday'].".".$timeArray['mon'].".".$timeArray['year'];

    echo <<<END
<h1>Dauerauftrag &auml;ndern</h1>
<form action="baui_standingorder.php?action=update" method="post">
<input type="hidden" name="bafv_lastexecuted" value="{$standingorder[lastexecuted]}" />
<input type="hidden" name="bafv_soid" value="{$standingorder[soid]}" />
<table>
<tr>
    <td><span class="mandatorylabel">Beg&uuml;nstigter:<br />Name, Vorname / Firma:</span></td>
    <td><input type="text" class="textfield" size="30" name="bafv_payeename" value="{$standingorder[payeename]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Konto-Nr. des Beg&uuml;nstigten:</span></td>
    <td><input type="text" class="textfield" size="10" name="bafv_toaccountid" value="{$standingorder[payeeaccountid]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Bankleitzahl:</span></td>
    <td><input type="text" class="textfield" size="10" name="bafv_tobankid" value="{$standingorder[payeebankid]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">W&auml;hrung:</span></td>
    <td><input type="text" class="textfield" size="10" name="bafv_currencyid" value="{$standingorder[currencyid]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Betrag:</span></td>
    <td><input type="text" class="textfield" size="10" name="bafv_amount" value="{$standingorder[amount]}" /></td></tr>
<tr>
    <td><span class="mandatorylabel">Verwendungszweck:</span></td>
    <td><input type="text" class="textfield" size="10" name="bafv_purpose" value="{$standingorder[purpose]}" /></td></tr>
END;
    display_time_params($standingorder);
    echo <<<END
<tr>
    <td><span class="mandatorylabel">N&auml;chste Ausf&uuml;hrung</span></td>
    <td><input type="text" class="textfield" size="10" name="bafv_nextexecution" value="{$nextexecution}" /></td></tr>
</table>
<input type="submit" class="functionbutton" name="bafv_submit_update" value="bernehmen" />
<input type="submit" class="backbutton" name="bafv_submit_back" value="Zur&uuml;ck" />
<input type="button"
name="bafv_submit_help" class="helpbutton" value="Hilfe" 
    onclick="javascript:displayHelp('form_de/bahl_customer_update.php');" />
</form>
<div class="message">$message</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Diplays a form for viewing a customer.
 *
 * @param message error message
 * @param standingorder standing order attributes
 */

function display_standingorder_display_form($message, $standingorder)
{
    global $minsoft_path;
    global $bafoso_periods;
    global $bafoso_weekdays;

    $v_function = "Dauerauftrag anzeigen";
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_head.php");

    echo <<<END
<h1>$v_function</h1>
<form action="baui_standingorder.php?action=read" method="post">
<table>
<tr>
    <td><span class="displaylabel">Beg&uuml;nstigter:</span></td>
    <td>{$standingorder['payeename']}</td></tr>
<tr>
    <td><span class="displaylabel">Konto-Nr. des Beg&uuml;nstigten:</span></td>
    <td>{$standingorder['payeeaccountid']}</td></tr>
<tr>
    <td><span class="displaylabel">Bankleitzahl:</span></td>
    <td>{$standingorder['payeebankid']}</td></tr>
<tr>
    <td><span class="displaylabel">W&auml;hrung:</span></td>
    <td>{$standingorder['currencyid']}</td></tr>
<tr>
    <td><span class="displaylabel">Betrag:</span></td>
    <td>{$standingorder['amount']}</td></tr>
<tr>
    <td><span class="displaylabel">Verwendungszweck:</span></td>
    <td>{$standingorder['purpose']}</td></tr>
<tr>
    <td><span class="displaylabel">Periode:</span></td>
    <td>
END;
    print($bafoso_periods[$standingorder['period']]);
    echo <<<END
</td></tr>
<tr><td>Tag: </td>
END;
    if($standingorder['period'] == 1)
        print("<td>".$bafoso_weekdays[$standingorder['time']]."</td></tr>\n");
    elseif($standingorder['period'] == 2) {
        $time = $standingorder['time'] + 1;
        print("<td>".$time.".</td></tr>\n");
    }
    else
        print("<td></td></tr>\n");
    $timarray = getdate($standingorder['nextexecution']);
    echo <<<END
<tr><td>N&auml;chste Ausf&uuml;hrung am:</td><td>{$timarray['mday']}.{$timarray['mon']}.{$timarray['year']}</td></tr>
<tr><td>Zuletzt ausgef&uuml;hrt am:</td><td>
END;

$loc = localtime($standingorder['lastexecuted'], true);
print($loc[ "tm_mday"] . "." . ($loc["tm_mon"]+1) . "." . ($loc["tm_year"] + 1900) . " "
        . $loc["tm_hour"] . ":" . $loc["tm_min"] . ":" . $loc["tm_sec"]);
    echo <<<END
</td></tr>
</table>
<br />
<input class="backbutton" type="submit" name="bafv_submit_back" value="Zur&uuml;ck" />
<input class="helpbutton" type="button" name="bafv_submit_help" value="Hilfe" onclick="javascript:displayHelp('form_de/bahl_customer_read.php');" />
</form>
<div class="message">$message</div>
END;
    include($minsoft_path."/template/".$_SESSION['baui_bankid']."_foot.php");
}

/**
 * Displays input fields for period and time
 *
 * @param standingorder standing order attributes
 */
function display_time_params($standingorder) {
    global $bafoso_periods;
    global $bafoso_weekdays;

    echo <<<END
    <tr><td><span class="mandatorylabel">H&auml;ufigkeit:</span></td>
<td>
END;
    for($i=0; $i<sizeof($bafoso_periods); $i++) {
        print(" <input type=\"radio\" name=\"bafv_period\" value=\"".$i."\"");
        if($i == $standingorder['period'])
            print(" checked=\"checked\"");
        print(">&nbsp;".$bafoso_periods[$i]);
    }
    echo <<<END
</td></tr>
<tr><td valign="top"><span class="mandatorylabel">Zeitpunkt:</span></td>
<td>
<table>
<tr><td valign="top">Wochentag bei w&ouml;chentlich:</td><td>
END;
    for($i=0; $i<7; $i++) {
        print(" <input type=\"radio\" name=\"bafv_weekly\" value=\"".$i."\"");
        if($standingorder['period'] == 1 && $i == $standingorder['time'])
            print(" checked=\"checked\"");
        print(">&nbsp;".$bafoso_weekdays[$i]);
        if(($i+1)%2 == 0)
            print("<br />\n");
    }
    echo <<<END
</td></tr>
<tr><td valign="top">Tag bei monatlich:</td><td>
END;
    for($i=0; $i<31; $i++) {
        print(" <input type=\"radio\" name=\"bafv_monthly\" value=\"".$i."\"");
        if($standingorder['period'] == 2 && $i == $standingorder['time'])
            print(" checked=\"checked\"");
        print ">&nbsp;".($i+1).". ";
        if(($i+1)%4 == 0)
            print("<br />\n");
    }

    print("</td></tr></table>\n");
    print("</td></tr>\n");
}
?>