<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
	<html>
		<head>
		<title>Schnittstellenbeschreibung</title>
		</head>
		<body>
			<h1>Schnittstellen-Beschreibung</h1>
			<p>Alle Werte werden in Listen beschrieben durch die Angaben 
			&quot;Name - Typ - Optional - Beschreibung&quot;</p>
			<xsl:apply-templates />
		</body>
	</html>
</xsl:template>

<xsl:template match="typeDescription">
	<h2>Typ <xsl:value-of select="@name"/></h2>
	<table>
	<tr><td><b>Basistyp:</b></td><td><xsl:value-of select="@basetype"/></td></tr>
	<tr><td><b>Beschreibung:</b></td><td><xsl:value-of select="@desc"/></td></tr>
	</table>
	<ul>
		<xsl:apply-templates />
   	</ul>
</xsl:template>

<xsl:template match="methodDescription">
	<h2>Methode <xsl:value-of select="@name"/></h2>
	<xsl:apply-templates />
</xsl:template>

<xsl:template match="author">
	<b>Autor: </b><xsl:value-of select="."/><br />
</xsl:template>

<xsl:template match="version">
	<b>Version: </b><xsl:value-of select="."/><br />
</xsl:template>

<xsl:template match="purpose">
	<b>Beschreibung: </b><xsl:value-of select="."/><br />
</xsl:template>

<xsl:template match="params">
	<h3>Parameter</h3>
	<ul>
		<xsl:apply-templates />
   	</ul>
</xsl:template>

<xsl:template match="returns">
	<h3>Rckgabewerte</h3>
	<ul>
		<xsl:apply-templates />
   	</ul>
</xsl:template>

<xsl:template match="value">
	<li>
  		<xsl:value-of select="@name"/> -
   		<xsl:value-of select="@type"/> -
   		<xsl:value-of select="@optional"/> -
   		<xsl:if test="@type != 'struct' and @type != 'array'">
   			<xsl:value-of select="."/>
   		</xsl:if>
   		<xsl:if test="@type = 'struct' or @type = 'array'">
   			<ul>
				<xsl:apply-templates />
   			</ul>
   		</xsl:if>
	</li>
</xsl:template>

<xsl:template match="see">
	<table>
	<tr><td valign="top"><b>Siehe auch:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

<xsl:template match="examples">
	<table>
	<tr><td valign="top"><b>Beispiele:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

<xsl:template match="errors">
	<table>
	<tr><td valign="top"><b>Fehlermeldungen:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

<xsl:template match="notes">
	<table>
	<tr><td valign="top"><b>Anmerkungen:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

<xsl:template match="bugs">
	<table>
	<tr><td valign="top"><b>Programmefehler:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

<xsl:template match="todos">
	<table>
	<tr><td valign="top"><b>Zu tun:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

<xsl:template match="history">
	<table>
	<tr><td valign="top"><b>Historie:</b></td><td><table>
   	<xsl:for-each select="item">
   		<tr><td><xsl:value-of select="@name" /></td>
   			<td>- <xsl:value-of select="." /></td></tr>
   	</xsl:for-each>
   	</table></td></tr></table>
</xsl:template>

</xsl:stylesheet>
