<?php
// This is the local interface to access the use
// business object by the XMLRPC interface.

// Konfigurationsdatei des "Calculators"
$current = dirname(__FILE__);
require_once ("$current/../usgn_config.php");

// XML-RPC-Client-Utility
require_once("$minsoft_path/utility/utxr_client.php");

// administrate users
class UserLi
{        
    // read user
    function read($secId, $lang, $userid)
    {
        return $this->us_call('user.read', array($secId, $lang, $userid)); 
    }

    // add new user    
    function add($secId, $lang, $user)
    {
        return $this->us_call('user.add', array($secId, $lang, $user)); 
    }
    
    // update user
    function update($secId, $lang, $user)
    {
        return $this->us_call('user.update', array($secId, $lang, $user)); 
    }
    
    // delete user
    function del($secId, $lang, $userid)
    {
        return $this->us_call('user.del', array($secId, $lang, $userid)); 
    }
    
    // list all users
    function listAll($secId, $lang)
    {
        return $this->us_call('user.list', array($secId, $lang)); 
    }
    
    // change password
    function changePassword($secId, $lang, $userid, $newPassword)
    {
        return $this->us_call('user.changePassword', array($secId, $lang, $userid, $newPassword)); 
    }

    // login and return security id
    function login($lang, $userid, $userpwd)
    {
        return $this->us_call('user.login', array($lang, $userid, $userpwd)); 
    }
    
    // Private Hilfsfunktion zum Aufruf
    function us_call($function, $params)
    {
        // Globale fr server-Adresse und Pfad vereinbaren
        global $xmlrpc_host, $xmlrpc_path, $xmlrpc_port;
                
        // Client-XMLRPC-Utility-Klasse instanziieren
        $client = new UTXRClient;
        
        // Server-Name, Remote-Interface-Pfad und HTTP-Port setzen
        $client->setServer($xmlrpc_host, $xmlrpc_path, $xmlrpc_port);
        
        // Funktion aufrufen und Ergebnis zurckgeben
        return $client->call($function, $params);
    }
}
?>