<?php
/**
 * User user interface: login
 *
 * $Source: /cvsroot/minbank/minba/user/ui_std/us_login.php,v $
 * $Author: mboller $
 * $Date: 2006/01/22 15:22:57 $
 * $Revision: 1.4 $
 */

require_once("../usgn_config.php");
require_once("$uscf_form_dir/usfo_login.php");
require_once("$uscf_form_dir/usfo_register.php");
require_once("$minsoft_path/ms_menu.php");
require_once("$minsoft_path/utility/utgn_config.php");
require_once("$minsoft_path/utility/utrl_role.php");
require_once("$minsoft_path/utility/utgn_fault.php");
require_once("$minsoft_path/utility/utgn_message.php");
require_once("$minsoft_path/utility/utgn_checkit.php");
require_once("$minsoft_path/utility/utxr_client.php");
require_once("$appl_path/$cf_local_interface/usli_user.php");
require_once "$minsoft_path/phplib/db_mysql.inc";
require_once("$minsoft_path/utility/utdb_access.php");


 // Falls die Anmeldung syntaktisch erfolgreich war, werden die Werte als
 // Sessionvariable gespeichert.

    session_start();
    $_SESSION['us_role'] = "";
    $_SESSION['us_id'] = "";
    $_SESSION['us_secId'] = "";

// Die Prfung der Eingabe wird initialisiert
// nur wenn der Button "Einloggen" bettigt wurde, werden die
// folgenden Prfungen Benutzername und Passwort durchgefhrt.
// Es wird geprft, ob Werte vorhanden sind und ob die Eingaben syntaktisch
// richtig sind. Im Falle eines Fehlers wird das Passwort in jedem Fall
// initialisert.

$inputerror = FALSE;
$usfv_msg="";

if(isset($_POST["usfv_register_submit"]))
	{
	  setup_registration();
	  exit;
	}

if(isset($_POST["usfv_submit"]))
{
      $usfv_id = $_POST["usfv_id"];

      // Feststellen welcher Fehler aufgetreten ist
      if(!checkit::isAlphaNum($_POST["usfv_id"],TRUE))
      {
          $inputerror[] = "Benutzerid";
      }
      if(!checkit::isAlphaNum($_POST["usfv_pwd"],TRUE))
      {
        $inputerror[] = "Passwort";
      }


      // Ausgabe eines oder mehrerer Fehler in demselben Formular
      if($inputerror &&(count($inputerror) == 1))
      {
          $usfv_msg= getMessage(211, $inputerror[0]);
          display_login_form();
      }
      elseif(count($inputerror)>1)
      {
          $usfv_msg = getMessage(210);
          $usfv_msg.=implode(",",$inputerror)."!";
          display_login_form();
      }

}
elseif(isset($_POST["usfv_register"]))
{
      $usfv_id = "";
      // Registrierungsformular wird angezeigt, der Benutzer kann Daten eingeben

      display_register_form("");
      exit;
}
// Vor dem ersten Anzeigen des Formulars wird die Benutzerid initialiert
else
{
      $usfv_id = "";
      // Anmeldeformular wird angezeigt, der Benutzer kann Daten eingeben
      display_login_form();
      exit;
}

/* Falls die Eingabe von Benutzername und Passwort vorhanden und syntaktisch richtig
   ist, werden diese Daten an die Datenbertragung zum Business Objekt bergeben
   und auf Antwort gewartet.
*/
if($inputerror == FALSE)
{
    $li = &new UserLi;

    // Abfragen, welcher Submit-Button verwendet wurde und die entsprechende
    // Funktion des Servers aufrufen. Erster Parameter von "call" ist der
    // Funktionsname, dann folgt ein Array mit Parametern.

    // Das Passwort muss noch in der Art und Weise verschlsselt werden, dass
    // der Wert mit dem Wert in der Datenbank bereinstimmt
    $scramble = md5($_POST["usfv_pwd"]);

    // Aufruf des xmlrpc servers mit den Parametern:
    // Objekt.Funktionsname in Business Schicht
    // Werte in einem array
    $result = $li->login($cf_lang, $_POST["usfv_id"], $scramble);

    // Fehlerbehandlung
    if(isFault($result))
    {
        $usfv_msg = $result[0]["faultString"];
        display_login_form();
        exit;
    }
    // Ausgabe der zurckgegebenen Werte:
    // SecurityId ( gltig fr diesen Benutzer)
    // Wert erhalten aus der Datenbank
    else
    {
        $_SESSION['us_secId'] = $result[1];
        $_SESSION['us_id'] = $usfv_id;
        settype($result[0],"integer");
        $_SESSION['us_role'] = $result[0];
        $usfv_msg="result ist: " .$result[0] . " SecId: " .$result[1];

        // Aufruf des MINSOFT menu
        display_ms_menu();
    }
}

/**
 * Sets up the registration.
 */
function setup_registration()
{

  $db = &new DBAccess();

  $id=$_POST['usfv_id'];
  $name=$_POST['usfv_name'];
  $mail=$_POST['usfv_email'];
  $pwd=md5($_POST['usfv_pwd']);

require("../usgn_config.php");
require("$minsoft_path/utility/utgn_config.php");

$sql = "SELECT userid FROM ".$utcv_db_prefix."user where userid='$id'";
  $bla=$db->query($sql);

   $N=$db->num_rows();
    if ($N>0)
    {
      display_register_form("Fehler: Dieser Benutzername wird bereits verwendet.");
      return 1;
    }


  $Buchstaben = array("A", "B", "C", "D", "E", "F", "G", "H", "K", "M", "N", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y","2", "3", "4", "5", "6", "7", "8", "9");

for($i = 0, $Code = ""; strlen($Code) < 10; $i++)
{
  $Buchstabe = $Buchstaben[rand(0, count($Buchstaben))];
  $Code .= $Buchstabe;
 }

 $registertext="Hallo ".$name."\n\n
Sie haben sich im MinSoft-Bankensystem angemeldet. Folgen Sie bitte folgendem Link:\n".$minsoft_url."/user/ui_std/ui_registration.php?code=$Code\n
um Ihre Registrierung zu besttigen\n\n<br>Ihre Systemadministration";

  $sql = "INSERT INTO {$utcv_db_prefix}user VALUES ('$id','$name','$pwd','$mail', 0)";
  $db->query($sql);


 $sql = "INSERT INTO {$utcv_db_prefix}user_reg VALUES ('$id','$Code')";
  $db->query($sql);

    mail($mail,'Anmeldung MinSoft-System',$registertext);

echo "Sie haben eine eMail an die Adresse $mail erhalten. Folgen Sie bitte den Anweisungen darin.";
}
return 0;

?>
