<?php 

class checkit {

  function filled($str) {
    return (strlen(trim($str)) > 0);
  }
  
  function check($str,$pattern,$mustfilled=false) {
    if (checkit::filled($str)) {
      $result = (preg_match($pattern,$str));
    } else {
      $result = (!($mustfilled));
    }
    return $result;
  }
  
  function isAlpha($str,$mustfilled=false) {
    return (checkit::check($str,"/^[a-zA-Z\. ,-]+$/", 
      $mustfilled));
  }

  function isNum($str,$mustfilled=false) {
    return (checkit::check($str,"/^\d+$/",$mustfilled));
  }
  
  function isAlphaNum($str,$mustfilled=false) {
    return (checkit::check($str,"/^[a-zA-Z0-9\. ,-]+$/", 
      $mustfilled));
  }
  
  function isNoHTML($str,$mustfilled=false) {
    return (checkit::check($str,"/^[^<>\"]+$/",$mustfilled));
  }

  function isSomeText($str,$mustfilled=false) {
    return (checkit::check($str,"/[a-zA-Z]+/",$mustfilled));
  }
  
  function isPhone($str,$mustfilled=false) {
    return (checkit::check($str,"/^[0-9\+][0-9\(\) -]+$/",$mustfilled));
  }
  
  function isEmail($str,$mustfilled=false) {
    return (checkit::check($str,
                 '#^[-!\#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
                 '@'.
                 '[-!\#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
                 '[-!\#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$#',
      $mustfilled));
  }
}

?>
