<?php

require_once("$minsoft_path/utility/utgn_trace.php");

class UTXRClient
{
    var $server;
    var $path;

    function UTXRClient() {
        global $safe_mode, $minsoft_path;
        if(! extension_loaded('xmlrpc'))
            if($safe_mode != "Off" || ! dl('php_xmlrpc.dll') )
                include_once("$minsoft_path/utility/utxr_epiemu.php");

        $this->server = '';
        $this->path = '';
    }
    
    function setServer($server, $path, $port=80)
    {
        $this->server = $server;
        $this->path = $path;
    }
    
    function call($function, $params)
    {
        // check if initialized
        if($this->server == '')
        {
            $result = getFault(2, 100);
            return $result;
        }
                
        // utgn_trace("call", "PARAM=".utgn_dump($params));    
        
        // code request to xml-rpc
        $request = xmlrpc_encode_request( $function, $params);
        
        // open http-socket
        $fp = fsockopen($this->server, 80, $errno, $errstr, 30);
        if (!$fp)
        {
            $result = $this->server.": $errstr ($errno)";
            return $result;
        }

        // send request using  http
        $send = "POST {$this->path} HTTP/1.0\r\n".
            "User-Agent: PHP XMLRPC 1.0\r\n".
            "Host: {$this->server}\r\n".
            "Content-type: text/xml\r\n".
            "Content-length: ".strlen($request)."\r\n\r\n".
            "$request";
            
        // utgn_trace("call", "REQUEST=".$send);
        
        fputs($fp, $send);
        
        // get result
        $xmlresult = '';
        // socket_set_timeout($fp, 10); // sometimes not supported
        while(!feof($fp)) {
            $line = fgets($fp, 256);
            $status = socket_get_status($fp);
            if($status['timed_out'])
            {
                $result = array(array("faultCode" => 9999, 
                        "faultString" => "Connection Timeout".$xmlresult));
                fclose($fp);
                return;
            }
            $xmlresult .= $line;
        }
        // close socket
        fclose($fp);
        
        // utgn_trace("call", "RESPONSE=".$xmlresult);
        
        // decode result
        if ( preg_match("/^HTTP\/[0-9\.]+ 200 /i" ,$xmlresult) )
        {
            preg_match("/(^HTTP\/.*)(\<\?xml.*$)/si",
                    $xmlresult, $matches);    

            if(is_array($matches) && count($matches) > 2 && $matches[2] != "")
            {
                $result = xmlrpc_decode_request($matches[2], &$method);
                // utgn_trace("call","RESULT=".utgn_dump($result));
            }
            else
            {
                $result = array(array("faultCode" => 9999, "faultString" => $xmlresult));
            }
        }
        else
        {
            $result = array(array("faultCode" => 9999, "faultString" => $xmlresult));
        }
        
        // utgn_trace("call", utgn_dump($result));
        return $result;
    }
}

?>
